#include <stdio.h>

#define BUFFERSIZE 32768
#define MAXFILE_LEN 100

#if defined(hpux) || (ibm) || (cray)
#define NO_UNDERSCORE
#endif
#if defined(linux) || (f2c) || (g77)
#define TWO_UNDERSCORES
#endif

/* routine to swap bytes from little- to big-endian (or vice versa) */
#ifdef NO_UNDERSCORE
void byte_swap(char *infile, char *outfile, int infile_len, int outfile_len)
#elif defined TWO_UNDERSCORES
void byte_swap__(char *infile, char *outfile, int infile_len, int outfile_len)
#else
void byte_swap_(char *infile, char *outfile, int infile_len, int outfile_len)
#endif

{
  FILE *fpin;
  FILE *fpout;
  int i;
  int nread, nwrite;
  char word[BUFFERSIZE];
  char filein[MAXFILE_LEN], fileout[MAXFILE_LEN];
  /* the SUN compiler won't allow this
     char filein[infile_len+1], fileout[outfile_len+1]; */

  /* check that filenames are not too long */
  if (MAXFILE_LEN <= infile_len | MAXFILE_LEN <= outfile_len){
    (void)printf("Filenames too long in byte_swap\n");
    exit(1);
  }

  /* open files for i/o */
  for (i=0; i<infile_len; i++) filein[i]=infile[i];
  filein[infile_len]='\0';
  for (i=0; i<outfile_len; i++) fileout[i]=outfile[i];
  fileout[outfile_len]='\0';
  fpin = fopen(filein,"r");
  if (fpin == NULL){
    (void)printf("Error opening r file, %s.\n",filein);
    exit(1);
  }
  fpout = fopen(fileout,"w");
  if (fpout == NULL){
    (void)printf("Error opening w file, %s.\n",fileout);
    exit(1);
  }

  /* read a buffer of words, swap bytes, then write out */
  while ((nread=fread(word,1,BUFFERSIZE,fpin))!=0) {
    if (4*(nread/4)!=nread){
      (void)printf("File %s is not a multiple of 4 bytes long!\n",filein);
      (void)printf("nread =%d\n",nread);
      exit(1);
    }
    for (i=0; i<nread; i=i+4) (void)byte_swap4(word+i);
    nwrite=fwrite(word,1,nread,fpout);
  }
  fclose(fpin);
  fclose(fpout);
  return;
}

/* swaps the bytes in a 4-byte word */
int byte_swap4(char word[4]) {
char temp1, temp2;

   temp1 = word[0];
   word[0] = word[3];
   word[3] = temp1;

   temp2 = word[1];
   word[1] = word[2];
   word[2] = temp2;

   return 0;
}
