c cosmic depends upon the following routines:
c       zdisp, displ, potin, gridf10, interp, greenf, greenfc,
c       ran3, fourn, pow, dumpdata, timeah
c
      PROGRAM cosmic
c
      include 'psize.inc'
      include 'pinfo.inc'
#include "rvarrays.inc"
      include 'iodefs.inc'
      include 'itype.inc'
c
      real index
      character greendir*8
      common /greendir/greendir
      common /spectrum/ispectrum,index,omegahh,h0
c
#ifdef ISOLATED
      print*,'***Warning*** You have compiled with -DISOLATED'
#endif
#ifdef NOEXPAND
      print*,'***Warning*** You have compiled with -DNOEXPAND'
#endif
c
      greendir='greenfn/'
      open(55,file='cosmic.dat',status='old')
      read(55,*) irun,iseed1
      read(55,*) ndark
      read(55,*) box100,h100
      read(55,*) omega0,xlambda0
      read(55,*) omegab0,gamma
      read(55,*) ispectrum,index
      read(55,*) atime,sigma80
      read(55,*) lcool,zmet0
      close(55)
c
      h0=h100
c
      L=2**nint(log(float(ndark)**(1./3.))/log(2.))
      if (L**3.ne.ndark) STOP 'ndark**(1/3) must be power-of-2' 
      if (L.lt.4) STOP 'ndark must be at least 4**3'
      if (L.gt.Lmax) STOP 'ndark must not exceed Lmax**3'
c
      ngas=0
      if (omegab0.gt.0.) ngas=ndark
#ifdef NOSPH
      if (ngas.gt.0) 
     &     STOP 'cosmic: omegab>0. is incompatible with -DNOSPH'
#endif
      nobj=ndark+ngas
      fgas=omegab0/omega0
      fdark=1.-fgas
      rmbary=fgas*ngas
      box=box100/h100
      soft=0.01          !unimportant except to prevent division by zero
c  output times for dump files
      CALL timeah(tstart,omega0,xlambda0,atime,htime)
      CALL timeah(tout1(1),omega0,xlambda0,0.090909,hjunk)
      CALL timeah(tout1(2),omega0,xlambda0,0.166666,hjunk)
      CALL timeah(tout1(3),omega0,xlambda0,0.25,hjunk)
      CALL timeah(tout1(4),omega0,xlambda0,0.333333,hjunk)
      CALL timeah(tout1(5),omega0,xlambda0,0.4,hjunk)
      CALL timeah(tout1(6),omega0,xlambda0,0.5,hjunk)
      CALL timeah(tout1(7),omega0,xlambda0,0.666667,hjunk)
      CALL timeah(tout1(8),omega0,xlambda0,1.,hjunk)
      time=tstart
      if (gamma.le.1e-4 .and. ispectrum.gt.1) then
         gamma=omega0*h100*exp(-omegab0*(1.+1./omega0))
         write(*,*) 'Using gamma = ',gamma
      end if
      omegahh=gamma*h100
c
c  normalise power spectrum
      if (abs(xlambda0).lt.1e-4) then
         omega=omega0/(omega0+atime*(1.-omega0))
         gom0=2.5*omega0/(1.+0.5*omega0+omega0**(4./7.))
         gom=2.5*omega/(1.+0.5*omega+omega**(4./7.))
      else if (abs(xlambda0+omega0-1.).lt.1e-4) then
         omega=omega0/(omega0+atime**3*(1.-omega0))
         gom0=2.5*omega0/((1./70.)+(209./140.)*omega0
     &        -(1./140.)*omega0**2+omega0**(4./7.))
         gom=2.5*omega/((1./70.)+(209./140.)*omega
     &        -(1./140.)*omega**2+omega**(4./7.))
      else
         STOP 'Don''t know how to do the sigma8 normalisation'
      end if
      sigma8=sigma80*atime*gom/gom0
      rth=8./h100
      delta=sigma8/pnorm(rth,box)
c
      call grid0(L,ndark,r)
c
c  calculate displacements
      perr=7.7
      ial=1       !set ial=1 when nobj=l**3 in greenfc.  I don't know why.
      spc=1.
      call zdisp(soft,perr,ial,spc,delta,iseed1,
     x box,Usm,Uf,Us,ndark,r,v,L)
c
c  write out results
c  first positions only for peakfindfft
      open(7,file='data/r.pert',form='unformatted',status='unknown')
      write(7) L,ndark,rth/box,sigma8
      call writer(7,ndark,r)
      close(7)
c  now hydra file
      rscalei=1./float(L)
      do i=1,ndark
         itype(i)=itdark
         rm(i)=fdark
         do j=1,3
            r(j,i)=rscalei*(r(j,i)-1.)
            v(j,i)=rscalei*v(j,i)/time
         end do
#ifndef NOSPH
         itype(i)=itgas
         rm(i)=fgas
c  set e to zero.  It will be set to a small, non-zero temp in startup.
         e(i)=0.
         dn(i)=1.
         h(i)=rscalei
#endif
      end do
#ifndef NOSPH
      do i=ndark+1,2*ndark
         itype(i)=itdark
         rm(i)=fdark
         do j=1,3
            r(j,i)=r(j,i-ndark)
            v(j,i)=v(j,i-ndark)
         end do
      end do
#endif
c
      write(datafile,'(''d'',i4.4,''.'',i4.4)')irun,0
      CALL dumpdata
c
      stop
      end
c-------------------------------------------------------------
      subroutine zdisp(soft,perr,ial,spc,delta,iseed,
     x   rLbox,Usm,Uf,Us,N,r,v,L)
      include 'psize.inc'
c
      real r(3,N),v(3,N)
c
      integer ll(Nmax),ihc(Lsmax3)

      real pf(Lmaxc3)
c
      complex dc(Lmax,Lmax,Lmax)
      real d3(Lmax,Lmax,Lmax),frc(Lmax,Lmax,Lmax)
      equivalence(dc,d3),(dc(1,1,Lmaxc),frc)
      equivalence(dc,ll),(dc(1,1,Lmaxc),ihc)
c
      sft=soft
      call greenf(ial,L,pf)
      call potin(sft,Ui,Usmth,delta,iseed,
     x     rLbox,L,dc,d3,pf)
      call displ(N,r,v,L,d3,frc)
c
      return
      end
c-----------------------------------------------------------
      subroutine displ(N,r,v,L,d3,frc)
c
      real d3(L,L,L),frc(L,L,L)
      real r(3,N),v(3,N)
c
      do 1 i=1,N
         v(1,i)=0.
         v(2,i)=0.
         v(3,i)=0.
 1    continue
c
      rL=float(L)
      rL1=10.*rL-1.
      hst=2./3.
      do 2 ic=1,3
         call gridf10(ic,d3,frc,L)
         call interp(ic,N,r,v,L,frc)
 2    continue
c
      rL=float(L)
      rL1=10.*rL-1.
      hst=2./3.
      do 3 i=1,N
         r(1,i)=mod(r(1,i)+v(1,i)+rL1,rL)+1.
         r(2,i)=mod(r(2,i)+v(2,i)+rL1,rL)+1.
         r(3,i)=mod(r(3,i)+v(3,i)+rL1,rL)+1.
         v(1,i)=hst*v(1,i)
         v(2,i)=hst*v(2,i)
         v(3,i)=hst*v(3,i)
 3    continue
c
      return
      end
c----------------------------------------------------------------
      subroutine potin(softg,Ui,Usmth,delta,iseed,
     x     rLbox,L,dc,d3,pf)
      parameter(tpi=6.28318530717959)
c  spectrum shaping near Nyquist frequency
      parameter(pi=3.141592,rke=0.8*pi,Ne=16)
c
      complex dc(L,L,L)
      real d3(L,L,L)
      real pf(L/2+1,L/2+1,L/2+1)
c
      integer nn(3)
      shp2(x)=12.*(2.-2.*cos(x)-x*sin(x))/x**4
c
      Lc=L/2+1
      ndim=3
      nn(1)=L
      nn(2)=L
      nn(3)=L
      rL=float(L)
      tpiL=tpi/rL
      rLb=rL/rLbox
      ampnorm=delta/rLbox**3
      Ui=0.
      Usmth=0.
      iseedt=iseed
c
      do 300 iz=1,Lc
       icz=mod(L+1-iz,L)+1
       do 300 iy=1,Lc
        icy=mod(L+1-iy,L)+1
        do 300 ix=1,Lc
         icx=mod(L+1-ix,L)+1
         rk=tpiL*sqrt(float((ix-1)**2+(iy-1)**2+(iz-1)**2))
         rkrl=rk*rLb
         efac=0.
         if(pf(ix,iy,iz).ne.0.)then
          Sprf2=(shp2(softg*rk/2.))**2
          efac=1./(pf(ix,iy,iz)*rk)**2
          if(ix.eq.1 .or. ix.eq.Lc)efac=0.5*efac
          if(iy.eq.1 .or. iy.eq.Lc)efac=0.5*efac
          if(iz.eq.1 .or. iz.eq.Lc)efac=0.5*efac
         end if
         amp=ampnorm*sqrt(pow(rkrl))*exp(-(rk/rke)**Ne)
         amp=amp*pf(ix,iy,iz)
c
         ampran=amp
         arg1=tpi*ran3(iseedt)
         Utem=ampran**2
         dc(ix ,iy ,iz )=ampran*cmplx(cos(arg1),sin(arg1))
         dc(icx,icy,icz)=conjg(dc(ix ,iy ,iz ))
         ampran=amp
         arg2=tpi*ran3(iseedt)
         Utem=Utem+ampran**2
         dc(ix ,iy ,icz)=ampran*cmplx(cos(arg2),sin(arg2))
         dc(icx,icy,iz )=conjg(dc(ix ,iy ,icz))
         ampran=amp
         arg3=tpi*ran3(iseedt)
         Utem=Utem+ampran**2
         dc(ix ,icy,iz )=ampran*cmplx(cos(arg3),sin(arg3))
         dc(icx,iy ,icz)=conjg(dc(ix ,icy,iz ))
         ampran=amp
         arg4=tpi*ran3(iseedt)
         Utem=Utem+ampran**2
         dc(ix ,icy,icz)=ampran*cmplx(cos(arg4),sin(arg4))
         dc(icx,iy ,iz )=conjg(dc(ix ,icy,icz))
c
         Utem=Utem*efac
         Ui=Ui+Utem
         Usmth=Usmth+Utem*Sprf2
300   continue
c
      call fourn(dc,nn,ndim,-1)
c
      trt=2.*sqrt(2.)
      do 210 iz=1,L
       do 210 iy=1,L
        do 210 ix=1,L
           d3(ix,iy,iz)=real(dc(ix,iy,iz))
 210  continue
c
      return
      end
c--------------------------------------------------------------------
c
c Omega L**3/nobj/6pi, Fourier sum normalization 1/L**3, FT of 1/r 4pi
c
      subroutine greenf(ial,L,pf)
c
      dimension pf(L/2+1,L/2+1,L/2+1)
c
      character*60 greenfile,vf,filename
      character*8 greendir
c
      common /greendir/greendir
c
      klf=int(log10(float(L)))+1
      kif=int(log10(float(max(abs(ial),1))))+1
c
      write(vf,
     &'(''(''''grnfL'''',i'',i1,'',''''i'''',i'',i1,''.'',i1,'')'')')
     &klf,kif,kif
c
      write(greenfile,vf)L,ial
c
      filename=greendir//greenfile
      open(11,file=filename,status='old',form='unformatted',err=444)
      read(11)Lf,ialf
      read(11)pf
      goto 666
c
 444  call greenfc(ial,L,pf)
      write(6,'(''Calculated Green''''s function '',a)')greenfile
c
      open(11,file=filename,status='new',form='unformatted')
      write(11)L,ial
      write(11)pf
c
 666  close(11)
c
      return
      end
c-----------------------------------------------------------------
      subroutine greenfc(ifl,L,gp3)
c      parameter(tpi=6.28318530717959,ipn=2,isgn=1-2*mod(ipn,2))
c
c On systems that do not allow functions inside parameter statements
c you should use the following (unless you have changed ipn)
      parameter(tpi=6.28318530717959,ipn=2,isgn=1)
c
      dimension gp3(L/2+1,L/2+1,L/2+1)
c
      tpiL=tpi/float(L)
      L2=L/2
      Lc=L/2+1
c
      do 400 igz=1,Lc
       rkz=tpiL*float(igz-1)
       s1z=sin(rkz)
       c1z=cos(rkz)
       s2z=sin(rkz/2.)
       psz=2.*s2z
       pz=1.
       if(igz.ne.1)pz=psz/rkz
       do 400 igy=1,igz
        rky=tpiL*float(igy-1)
        s1y=sin(rky)
        c1y=cos(rky)
        s2y=sin(rky/2.)
        psy=2.*s2y
        py=1.
        if(igy.ne.1)py=psy/rky
        do 400 igx=1,igy
         rkx=tpiL*float(igx-1)
         s1x=sin(rkx)
         c1x=cos(rkx)
         s2x=sin(rkx/2.)
         psx=2.*s2x
         px=1.
         if(igx.ne.1)px=psx/rkx
         gp3t=0.
c
         itest=mod(igx-1,L2)+mod(igy-1,L2)+mod(igz-1,L2)
c
         if(itest.ne.0)then
c
          rk2=rkx*rkx+rky*rky+rkz*rkz
c
          Smp=0.
          do 500 nz=-ipn,ipn
           rkzn=rkz-tpi*nz
           qz=1.
           if(rkzn.ne.0.)qz=psz/rkzn
           do 500 ny=-ipn,ipn
            rkyn=rky-tpi*ny
            qy=1.
            if(rkyn.ne.0.)qy=psy/rkyn
            do 500 nx=-ipn,ipn
             rkxn=rkx-tpi*nx
             qx=1.
             if(rkxn.ne.0.)qx=psx/rkxn
c
             qt=(qx*qy*qz)**3
c
             Smp=qt-Smp
500       continue
          Smp=isgn*Smp
c
          Dkx1=s1x*(1.+c1y+c1z)
          Dky1=s1y*(1.+c1z+c1x)
          Dkz1=s1z*(1.+c1x+c1y)
c
          Dkx=2.*Dkx1
          Dky=2.*Dky1
          Dkz=2.*Dkz1
c
          if(ifl.eq.0)Smp=(px*py*pz)**3
          gp3t=0.5/((rkx*Dkx+rky*Dky+rkz*Dkz)*Smp)
c
         end if
         gp3(igx,igy,igz)=gp3t
         gp3(igx,igz,igy)=gp3t
         gp3(igy,igz,igx)=gp3t
         gp3(igy,igx,igz)=gp3t
         gp3(igz,igx,igy)=gp3t
         gp3(igz,igy,igx)=gp3t
400   continue
c
      return
      end
c-----------------------------------------------------------------
      FUNCTION RAN3(IDUM)
      SAVE
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1.E-9)
      DIMENSION MA(55)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
        IFF=1
        MJ=MSEED-IABS(IDUM)
        MJ=MOD(MJ,MBIG)
        MA(55)=MJ
        MK=1
        DO 11 I=1,54
          II=MOD(21*I,55)
          MA(II)=MK
          MK=MJ-MK
          IF(MK.LT.MZ)MK=MK+MBIG
          MJ=MA(II)
11      CONTINUE
        DO 13 K=1,4
          DO 12 I=1,55
            MA(I)=MA(I)-MA(1+MOD(I+30,55))
            IF(MA(I).LT.MZ)MA(I)=MA(I)+MBIG
12        CONTINUE
13      CONTINUE
        INEXT=0
        INEXTP=31
        IDUM=1
      ENDIF
      INEXT=INEXT+1
      IF(INEXT.EQ.56)INEXT=1
      INEXTP=INEXTP+1
      IF(INEXTP.EQ.56)INEXTP=1
      MJ=MA(INEXT)-MA(INEXTP)
      IF(MJ.LT.MZ)MJ=MJ+MBIG
      MA(INEXT)=MJ
      RAN3=MJ*FAC
      RETURN
      END
c--------------------------------------------------------------------
      subroutine gridf10(ic,d3,frc,L)
c
      real d3(L,L,L),frc(L,L,L)
c
      L1=L-1
      if(ic.eq.1)then
       do 51 iz=1,L
        do 51 iy=1,L
         do 51 ix=1,L
          ixp1=mod(ix+1+L1,L)+1
          ixm1=mod(ix-1+L1,L)+1
          iyp1=mod(iy+1+L1,L)+1
          iym1=mod(iy-1+L1,L)+1
          izp1=mod(iz+1+L1,L)+1
          izm1=mod(iz-1+L1,L)+1
          frc(ix,iy,iz)=2.*(d3(ixp1,iy  ,iz  )-d3(ixm1,iy  ,iz  ))
c
     x                     +d3(ixp1,iyp1,iz  )-d3(ixm1,iyp1,iz  )
     x                     +d3(ixp1,iym1,iz  )-d3(ixm1,iym1,iz  )
     x                     +d3(ixp1,iy  ,izp1)-d3(ixm1,iy  ,izp1)
     x                     +d3(ixp1,iy  ,izm1)-d3(ixm1,iy  ,izm1)
 51    continue
      else if(ic.eq.2)then
       do 52 iz=1,L
        do 52 iy=1,L
         do 52 ix=1,L
          ixp1=mod(ix+1+L1,L)+1
          ixm1=mod(ix-1+L1,L)+1
          iyp1=mod(iy+1+L1,L)+1
          iym1=mod(iy-1+L1,L)+1
          izp1=mod(iz+1+L1,L)+1
          izm1=mod(iz-1+L1,L)+1
          frc(ix,iy,iz)=2.*(d3(ix  ,iyp1,iz  )-d3(ix  ,iym1,iz  ))
c
     x                     +d3(ixp1,iyp1,iz  )-d3(ixp1,iym1,iz  )
     x                     +d3(ixm1,iyp1,iz  )-d3(ixm1,iym1,iz  )
     x                     +d3(ix  ,iyp1,izp1)-d3(ix  ,iym1,izp1)
     x                     +d3(ix  ,iyp1,izm1)-d3(ix  ,iym1,izm1)
 52    continue
      else if(ic.eq.3)then
       do 53 iz=1,L
        do 53 iy=1,L
         do 53 ix=1,L
          ixp1=mod(ix+1+L1,L)+1
          ixm1=mod(ix-1+L1,L)+1
          iyp1=mod(iy+1+L1,L)+1
          iym1=mod(iy-1+L1,L)+1
          izp1=mod(iz+1+L1,L)+1
          izm1=mod(iz-1+L1,L)+1
          frc(ix,iy,iz)=2.*(d3(ix  ,iy  ,izp1)-d3(ix  ,iy  ,izm1))
c
     x                     +d3(ix  ,iyp1,izp1)-d3(ix  ,iyp1,izm1)
     x                     +d3(ix  ,iym1,izp1)-d3(ix  ,iym1,izm1)
     x                     +d3(ixm1,iy  ,izp1)-d3(ixm1,iy  ,izm1)
     x                     +d3(ixp1,iy  ,izp1)-d3(ixp1,iy  ,izm1)
 53    continue
      end if
c
      return
      end
c------------------------------------------------------------
      subroutine interp(ic,N,r,v,L,frc)
c
      real r(3,N),v(3,N)
      real frc(L,L,L)
c
       do 1 i=1,N
        rrx=r(1,i)
        rry=r(2,i)
        rrz=r(3,i)
        ix= int(rrx+0.5)
        iy= int(rry+0.5)
        iz= int(rrz+0.5)
        hx = rrx -ix
        hy = rry -iy
        hz = rrz -iz
        ix=mod(ix-1,L)+1
        iy=mod(iy-1,L)+1
        iz=mod(iz-1,L)+1
c
        hx0=0.75 - hx*hx
        hxp1=0.5* (0.5 + hx)**2
        hxm1=0.5* (0.5 - hx)**2
        hy0=0.75 - hy*hy
        hyp1=0.5* (0.5 + hy)**2
        hym1=0.5* (0.5 - hy)**2
        hz0=0.75 - hz*hz
        hzp1=0.5* (0.5 + hz)**2
        hzm1=0.5* (0.5 - hz)**2
        ixp1=mod(ix,L)+1
        iyp1=mod(iy,L)+1
        izp1=mod(iz,L)+1
        ixm1=mod(ix-2+L,L)+1
        iym1=mod(iy-2+L,L)+1
        izm1=mod(iz-2+L,L)+1
        ac =   frc(ixm1,iym1,izm1)* hxm1*hym1 *hzm1
     x        +frc(ix  ,iym1,izm1)* hx0 *hym1 *hzm1
     x        +frc(ixp1,iym1,izm1)* hxp1*hym1 *hzm1
     x        +frc(ixm1,iy  ,izm1)* hxm1*hy0  *hzm1
     x        +frc(ix  ,iy  ,izm1)* hx0 *hy0  *hzm1
     x        +frc(ixp1,iy  ,izm1)* hxp1*hy0  *hzm1
     x        +frc(ixm1,iyp1,izm1)* hxm1*hyp1 *hzm1
     x        +frc(ix  ,iyp1,izm1)* hx0 *hyp1 *hzm1
     x        +frc(ixp1,iyp1,izm1)* hxp1*hyp1 *hzm1
     x        +frc(ixm1,iym1,iz  )* hxm1*hym1 *hz0
     x        +frc(ix  ,iym1,iz  )* hx0 *hym1 *hz0
     x        +frc(ixp1,iym1,iz  )* hxp1*hym1 *hz0
     x        +frc(ixm1,iy  ,iz  )* hxm1*hy0  *hz0
     x        +frc(ix  ,iy  ,iz  )* hx0 *hy0  *hz0
      ac = ac
     x        +frc(ixp1,iy  ,iz  )* hxp1*hy0  *hz0
     x        +frc(ixm1,iyp1,iz  )* hxm1*hyp1 *hz0
     x        +frc(ix  ,iyp1,iz  )* hx0 *hyp1 *hz0
     x        +frc(ixp1,iyp1,iz  )* hxp1*hyp1 *hz0
     x        +frc(ixm1,iym1,izp1)* hxm1*hym1 *hzp1
     x        +frc(ix  ,iym1,izp1)* hx0 *hym1 *hzp1
     x        +frc(ixp1,iym1,izp1)* hxp1*hym1 *hzp1
     x        +frc(ixm1,iy  ,izp1)* hxm1*hy0  *hzp1
     x        +frc(ix  ,iy  ,izp1)* hx0 *hy0  *hzp1
     x        +frc(ixp1,iy  ,izp1)* hxp1*hy0  *hzp1
     x        +frc(ixm1,iyp1,izp1)* hxm1*hyp1 *hzp1
     x        +frc(ix  ,iyp1,izp1)* hx0 *hyp1 *hzp1
     x        +frc(ixp1,iyp1,izp1)* hxp1*hyp1 *hzp1
c
       v(ic,i)=v(ic,i)+ac
c
 1    continue
c
      return
      end
c--------------------------------------------------------------
      SUBROUTINE FOURN(DATA,NN,NDIM,ISIGN)
      DOUBLE PRECISION WR,WI,WPR,WPI,WTEMP,THETA
      DIMENSION NN(NDIM),DATA(*)
      NTOT=1
      DO 11 IDIM=1,NDIM
        NTOT=NTOT*NN(IDIM)
11    CONTINUE
      NPREV=1
      DO 18 IDIM=1,NDIM
        N=NN(IDIM)
        NREM=NTOT/(N*NPREV)
        IP1=2*NPREV
        IP2=IP1*N
        IP3=IP2*NREM
        I2REV=1
        DO 14 I2=1,IP2,IP1
          IF(I2.LT.I2REV)THEN
            DO 13 I1=I2,I2+IP1-2,2
              DO 12 I3=I1,IP3,IP2
                I3REV=I2REV+I3-I2
                TEMPR=DATA(I3)
                TEMPI=DATA(I3+1)
                DATA(I3)=DATA(I3REV)
                DATA(I3+1)=DATA(I3REV+1)
                DATA(I3REV)=TEMPR
                DATA(I3REV+1)=TEMPI
12            CONTINUE
13          CONTINUE
          ENDIF
          IBIT=IP2/2
1         IF ((IBIT.GE.IP1).AND.(I2REV.GT.IBIT)) THEN
            I2REV=I2REV-IBIT
            IBIT=IBIT/2
          GO TO 1
          ENDIF
          I2REV=I2REV+IBIT
14      CONTINUE
        IFP1=IP1
2       IF(IFP1.LT.IP2)THEN
          IFP2=2*IFP1
          THETA=ISIGN*6.28318530717959D0/(IFP2/IP1)
          WPR=-2.D0*SIN(0.5D0*THETA)**2
          WPI=SIN(THETA)
          WR=1.D0
          WI=0.D0
          DO 17 I3=1,IFP1,IP1
            DO 16 I1=I3,I3+IP1-2,2
              DO 15 I2=I1,IP3,IFP2
                K1=I2
                K2=K1+IFP1
                TEMPR=WR*DATA(K2)-WI*DATA(K2+1)
                TEMPI=WR*DATA(K2+1)+WI*DATA(K2)
                DATA(K2)=DATA(K1)-TEMPR
                DATA(K2+1)=DATA(K1+1)-TEMPI
                DATA(K1)=DATA(K1)+TEMPR
                DATA(K1+1)=DATA(K1+1)+TEMPI
15            CONTINUE
16          CONTINUE
            WTEMP=WR
            WR=WR*WPR-WI*WPI+WR
            WI=WI*WPR+WTEMP*WPI+WI
17        CONTINUE
          IFP1=IFP2
        GO TO 2
        ENDIF
        NPREV=N*NPREV
18    CONTINUE
      RETURN
      END
c--------------------------------------------------------------------
      function pnorm(r,box)
c
c  Measured value of sigma within sphere of radius r Mpc
c  Box is used to normalise power spectrum to make Fourier sum easier
c  (see pages 26-7 of Theory Book).
c
      parameter(tpi=6.28318530717959,pi=tpi/2)
      common /tophat/rth
      external rint,rintlog
c
      rth=r
      if (rth.lt.100.) then
         CALL qromb(rint,0.,1.,sig2low)
         CALL qromb(rintlog,0.,log(10./rth),sig2high)
         sig2=sig2low+sig2high
      else
         CALL qromb(rint,0.,100./rth,sig2)
      end if
      sig2=4.*pi/tpi**3/box**3*sig2
      pnorm=sqrt(sig2)
c
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      function rint(x)
c
      common /tophat/rth
c
      rint=w(rth*x)*pow(x)*x**2
c
      RETURN
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      function rintlog(x)
c
      common /tophat/rth
c
      y=exp(x)
      rintlog=w(rth*y)*pow(y)*y**3
c
      RETURN
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      function w(x)
c
      if (x.le.1e-2) then
         w=1.-0.2*x**2
      else
         w=9.*(sin(x)-x*cos(x))**2/x**6
      end if
c
      RETURN
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      function pow(rk)
c  pow evaluates the power spectrum at wavenumber rk.
c  N.B. rk has units of 1/Mpc (no h).
c
      real ind
      common /spectrum/ispec,ind,omegahh,h100
c
c  things needed for CMBFast table lookup
      parameter(ntabmax=1001)
      real rklogtab(ntabmax),tlogtab(ntabmax)
      logical firstcall
      save firstcall,rkmin,rkmax,ntab,rklogtab,tlogtab
      data firstcall/.true./
c
      if (rk.le.0.0) then
        pow=0.0
        RETURN
      end if
c
      if (ispec.eq.0) then
c  Tabulated transfer function in CMBFast format
         if (firstcall) then
c  Read in table
            firstcall=.false.
            open(13,file='tfunc.dat',iostat=ier)
            if (ier.ne.0) STOP 'error opening tfunc.dat'
            ntab=0
            do while (.true.)
               read(13,*,end=10) rkcmbfast,tcdm,tbary,tphot,tneut
               ntab=ntab+1
               if (ntab.gt.ntabmax) STOP 'pow: ntab>ntabmax'
c  Convert cmbfast k (units h/Mpc) to hydra k (units 1/Mpc)
               rklogtab(ntab)=log10(rkcmbfast*h100)
c  Use cdm power spectrum and ignore baryon one (the two are virtually 
c  identical except for baryon-dominated models).
               tlogtab(ntab)=log10(tcdm)
            end do
 10         close(13)
            rkmin=10.**rklogtab(1)
            rkmax=10.**rklogtab(ntab)
c  Not strictly necessary but normalise t to unity for small k
            tlogtab0=tlogtab(1)
            do itab=1,ntab
               tlogtab(itab)=tlogtab(itab)-tlogtab0
            end do
         end if
         if (rk.lt.rkmin .or. rk.gt.rkmax) then
            print*,'rkmin=',rkmin
            print*,'rkmax=',rkmax
            print*,'rk=',rk
            STOP 'pow: rk out of range'
         end if
         rklog=log10(rk)
         CALL hunt(rklogtab,ntab,rklog,it0)
c  Logarithmic interpolation
         it1=it0+1
         tlog=(tlogtab(it1)*(rklog-rklogtab(it0))
     &        +tlogtab(it0)*(rklogtab(it1)-rklog))
     &        /(rklogtab(it1)-rklogtab(it0))
         t=10.**tlog
         pow=rk*t**2
c
      else if (ispec.eq.1) then
c  Power Law
         q=rk
         pow=q**ind
c
      else if (ispec.eq.2) then
c  CDM
         q=rk/omegahh
c  Transfer function for cold dark matter from DEFW.
c  This has a higher maximum and a higher normalisation at large k than 
c  the others, so don't use it.
c         a1=1.7*q
c         a2=4.327*q
c         a3=1.0*q
c         t=1.0/(1.0+a1+a2*sqrt(a2)+a3*a3)
c  Transfer function for cold dark matter from Couchman (has the 
c  wrong asymptotic behaviour at high q).
c         q=0.25*q
c         a1=23.1*q
c         a2=11.4*q
c         a3=6.48*q
c         t=(1.+(a1+a2**1.5+a3**2)**1.25)**(-0.8)
c  Transfer function for cold dark matter (from BBKS).
         a1=2.34*q
         a2=3.89*q
         a3=16.1*q
         a4=5.46*q
         a5=6.71*q
         t=1.0+a2+a3*a3+a4*a4*a4+a5*a5*a5*a5
         t=log(1.0+a1)/a1/sqrt(sqrt(t))
         pow=q*t**2
      else if (ispec.eq.3) then
c  HDM
         q=rk/omegahh
c  Transfer function for hot dark matter (from BBKS).
         a1=2.6*q
         a2=1.6*q
         a3=4.0*q
         a4=0.92*q
         t=exp(-0.16*a1-0.5*a1*a1)/(1.0+a2+a3*sqrt(a3)+a4*a4)
         pow=q*t**2
      end if
c
      RETURN
      end
c----------------------------------------------------------------------
      SUBROUTINE timeah(t,omega0,xlambda0,a,h)
c
c  Evaluates the time t (in units of t0) and Hubble parameter (units 1/t0)
c  given the expansion factor a (=1 at t=1)
c  for cosmological parameters omega0 and lambda0 (evaluated at t=1).
c
      h0t0=aintegral(0.,1.,omega0,xlambda0)
      h0t=aintegral(0.,a,omega0,xlambda0)
      t=h0t/h0t0
      h=h0t0*sqrt(1.+omega0*(1./a-1.)+xlambda0*(a**2-1.))/a
      aold=a
c
      RETURN
      end
c-------------------------------------------------------------------
      real FUNCTION aintegral(a1,a2,omega,xlambda)
c
c  Does open-ended romberg integration of the a integral from a1 to a2
c  Based on a Numerical Recipes routine
c
      parameter (eps=1.e-6, jmax=14, jmaxp=jmax+1, k=5, km=k-1)
      real h(jmaxp),s(jmaxp)
      func(a,om,xla)=1/sqrt(1.+om*(1./a-1.)+xla*(a**2-1.))
c
      arange=a2-a1
      h(1)=1.
      do j=1,jmax
c  midpoint evaluation
	if (j.eq.1) then
           x=0.5*(a1+a2)
           s(j)=arange*func(x,omega,xlambda)
           it=1
	else
           tnm=it
           del=arange/(3.*tnm)
           ddel=2.*del
           x=a1+0.5*del
           sum=0.
           do jt=1,it
              sum=sum+func(x,omega,xlambda)
              x=x+ddel
              sum=sum+func(x,omega,xlambda)
              x=x+del
           end do
           s(j)=(s(j-1)+arange*sum/tnm)/3.
           it=3*it
	end if
c  extrapolate to zero step size
        if (j.ge.k) then
          CALL polint(h(j-km),s(j-km),k,0.,ss,dss)
          if (abs(dss).le.eps*abs(ss)) then
             aintegral=ss
             RETURN
          end if
        endif
        s(j+1)=s(j)
        h(j+1)=h(j)/9.
      end do
      STOP 'aintegral: too many steps'
c
      end
c
c--------------------------------------------------------
      subroutine writer(ichan,N,r)
c
      real r(3,N)
c
      write(ichan) r
c
      return
      end
c
      subroutine readr(ichan,N,r)
c
      real r(3,N)
c
      read(ichan) r
c
      return
      end
c
      subroutine grid0(L,N,r)
c
c  sets up grid centred on (1,1,1)
c
      integer L,N
      real r(3,N)
c
      rL=float(L)
      n1d=nint(float(N)**(1./3.))
      spc=rL/float(n1d)
c
      if(n1d**3 .ne. N .or. n1d .lt. L)stop 'bad spacing'
      n1d2=n1d*n1d
      do i=1,N
         r(1,i)=(mod(i-1,n1d)+0.5)*spc+1.
         r(2,i)=(mod((i-1)/n1d,n1d)+0.5)*spc+1.
         r(3,i)=(mod((i-1)/n1d2,n1d)+0.5)*spc+1.
      end do
c
      return
      end
c--------------------------------------------------
      SUBROUTINE hunt(xx,n,x,jlo)
c  finds position of entry in ordered table
c  value returned is the lower of the two bounding indices
c  0 is returned for underflows and n for overflows
      dimension xx(n)
      logical ascnd
      ascnd=xx(n).gt.xx(1)
      if(jlo.le.0.or.jlo.gt.n)then
        jlo=0
        jhi=n+1
        GOTO 3
      end if
      inc=1
      if(x.ge.xx(jlo).eqv.ascnd)then
1       jhi=jlo+inc
        if(jhi.gt.n)then
          jhi=n+1
        else if(x.ge.xx(jhi).eqv.ascnd)then
          jlo=jhi
          inc=inc+inc
          go to 1
        end if
      else
        jhi=jlo
2       jlo=jhi-inc
        if(jlo.lt.1)then
          jlo=0
        else if(x.lt.xx(jlo).eqv.ascnd)then
          jhi=jlo
          inc=inc+inc
          GOTO 2
        end if
      end if
3     if(jhi-jlo.eq.1)RETURN
      jm=(jhi+jlo)/2
      if(x.gt.xx(jm).eqv.ascnd)then
        jlo=jm
      else
        jhi=jm
      end if
      GOTO 3
      end
