      SUBROUTINE qromb(func,a,b,ss)
c  romberg integrator
c  uses polint,trapzd
      integer j,jmax,jmaxp,k,km
      real a,b,func,ss,eps
      parameter (eps=1.e-6, jmax=20, jmaxp=jmax+1, k=5, km=k-1)
      real dss,h(jmaxp),s(jmaxp)
      external func
c
      h(1)=1.
      do 11 j=1,jmax
        call trapzd(func,a,b,s(j),j)
        if (j.ge.k) then
          call polint(h(j-km),s(j-km),k,0.,ss,dss)
          if (abs(dss).le.eps*abs(ss)) return
        endif
        s(j+1)=s(j)
        h(j+1)=0.25*h(j)
11    continue
      write(*,*) 'too many steps in qromb'
      write(*,*) 'ss = ',ss,', dss = ',dss
      PAUSE 
      END
