      SUBROUTINE shforce(sfts,sftl,gamp,re,spc,rmdark,rmgas,
     &     ntp,G,D,dptlgas,dptldark)
c
c  Calculate the PP gravity tables
c
      real G(0:ntp+1),D(0:ntp+1)
c
      save sftso,sftlo,gampo
      data sftso,sftlo/-1.,-1./
c
      if(sfts.ne.sftso .or. sftl.ne.sftlo)then
c
      tpi=6.28318530717959
c
      df=1.
      sf=df
      re2=re**2
      delrad2=re2/float(ntp)
      delin=1./delrad2
      do 10 i=1,ntp
         rad2=delrad2*i
         rad=sqrt(rad2)
         CALL S2(rad,sfts,gs,ds)
         CALL S2(rad,sftl,gl,dl)
         G(i)=sf*(gs-gl)/rad
         D(i)=df*(ds-dl)
 10   continue
      rad0=sfts/1000.
      CALL S2(rad0,sfts,gs,ds)
      CALL S2(rad0,sftl,gl,dl)
      G(0)=sf*(gs-gl)/rad0
      D(0)=df*(ds-dl)
      G(ntp+1)=0.
      D(ntp+1)=0.
c
      dptl=0.
      dptlgas=0.
      dptldark=0.
      if(spc.gt.0.)then
c
       nz=int(re/spc)+1
       do 100 iz=1,nz
        do 100 iy=0,iz
         do 100 ix=0,iy
          r=spc*sqrt(float(ix**2+iy**2+iz**2))
c
          if(r.lt.re)then
             iprod=12
             if(iy.eq.iz .or. iz.eq.ix .or. ix.eq.iy)iprod=6
             if(ix.eq.iy .and. iy.eq.iz)iprod=2
             if(ix.gt.0)iprod=2*iprod
             if(iy.gt.0)iprod=2*iprod
c     
             CALL S2(r,sfts,gdum,ds)
             CALL S2(r,sftl,gdum,dl)
             dptl=dptl+(ds-dl)*iprod
          end if
c
100    continue
c The following assumes a dark matter and gas grid which are coincident
c with masses of rmdark and rmgas (per particle) respectively.
       CALL S2(rad0,sfts,gdum,ds)
       CALL S2(rad0,sftl,gdum,dl)
       dptl0=(ds-dl)
       if (rmgas.gt.0.) then
          dptldark=dptl*(rmdark+rmgas)+rmgas*dptl0
       else
          dptldark=dptl*rmdark
       end if
       if (rmdark.gt.0.) then
          dptlgas=dptl*(rmdark+rmgas)+rmdark*dptl0
       else
          dptlgas=dptl*rmgas
       end if
       if (gamp.eq.0.) then
          dptlgas=0.
          dptldark=0.
       end if
      end if
c
c       dptl=dptl/2.
c No divide by two as the gravity calculation is one-sided?
c
      gampo=1.
      end if
c
      if(gamp.ne.gampo)then
c
c  Note: should never divide by zero as gampo=0. implies gamp=gampo
      gfac=gamp/gampo
      do 200 i=0,ntp
       G(i)=G(i)*gfac
 200  continue
c
      end if
c
      sftso=sfts
      sftlo=sftl
      gampo=gamp
c
      RETURN
      end
c
c *********************************************************************
c
      SUBROUTINE green(soft,gamp,intl,L,gp3,diff)
c
      dimension gp3(L/2+1,L/2+1,L/2+1),diff(L/2+1,L/2+1,L/2+1)
c
      include 'iodefs.inc'
      character*60 greenfile,vf,longfile
c
      save Lo,softo,gampo
      data Lo,softo/-1,-1./
      data dpf/-1./
c
      shp2(x)=12.d0*(2.d0-2.d0*cos(dble(x))-dble(x)*sin(dble(x)))/
     x     dble(x)**4
c
      if(soft.ne.softo .or. L.ne.Lo)then
c
      klf=int(log10(float(L)))+1
      ksf=int(log10(soft))+5
c
      write(vf,'(''(''''grnL'''',i'',i1,'',''''s'''',f'',i1,''.3)'')')
     &     klf,ksf
c
      write(greenfile,vf)L,soft
c
      if(intl.eq.1)greenfile=greenfile(1:lnblnk(greenfile))//'I'
c
      longfile='greenfn/'//greenfile
      open(11,file=longfile,status='old',form='unformatted',err=444)
      read(11)Lf,intlf,softf
      err=abs(soft/softf-1.)
      if(err.gt.1.e-4)GOTO 444
      read(11)gp3,diff
      gampo=1.
      GOTO 666
c
 444  close(11,err=445)
 445  continue
c     
      tpi=6.28318530717959
c
      df=2.*tpi/(float(L**3)*(1.+intl))
      sf=df
c
      tpiL=tpi/float(L)
      L2=L/2
      Lc=L/2+1
      Le=L/4+1
c
      ipn=2
c
      af=2./15.
      do 400 igz=1,Lc
       rkz=tpiL*float(igz-1)
       s1z=sin(rkz)
       c1z=cos(rkz)
       s2z=sin(rkz/2.)
       s2z2=s2z**2
       psz=2.*sin(rkz/2.)
       sz=sin(rkz/4.)**2
       cz=1.-sz
       do 400 igy=1,igz
        rky=tpiL*float(igy-1)
        s1y=sin(rky)
        c1y=cos(rky)
        s2y=sin(rky/2.)
        s2y2=s2y**2
        psy=2.*sin(rky/2.)
        sy=sin(rky/4.)**2
        cy=1.-sy
        do 400 igx=1,igy
         rkx=tpiL*float(igx-1)
         s1x=sin(rkx)
         c1x=cos(rkx)
         s2x=sin(rkx/2.)
         s2x2=s2x**2
         psx=2.*sin(rkx/2.)
         cx=cos(rkx/4.)**2
         sx=1.-cx
         gp3t=0.
         difft=0.
c
         itest=mod(igx-1,L2)+mod(igy-1,L2)+mod(igz-1,L2)
c
         if(itest.ne.0)then
c
          rk2=rkx*rkx+rky*rky+rkz*rkz
c
          SUM=0.
          SRx=0.
          SRy=0.
          SRz=0.
          do 500 nz=-ipn,ipn
           rkzn=rkz-tpi*nz
           qz=1.
           if(rkzn.ne.0.)qz=psz/rkzn
           do 500 ny=-ipn,ipn
            rkyn=rky-tpi*ny
            qy=1.
            if(rkyn.ne.0.)qy=psy/rkyn
            do 500 nx=-ipn,ipn
             rkxn=rkx-tpi*nx
             qx=1.
             if(rkxn.ne.0.)qx=psx/rkxn
c
             rk2n=rkxn*rkxn+rkyn*rkyn+rkzn*rkzn
c 
             Sprf=shp2(soft*sqrt(rk2n)/2.)
             st=Sprf*Sprf/rk2n
c
             st=st*(qx*qy*qz)**6
             SUM=SUM+st
             SRx=SRx+rkxn*st
             SRy=SRy+rkyn*st
             SRz=SRz+rkzn*st
500       continue
c
          SAa=(1.+s2x2*(af*s2x2-1.))
     &       *(1.+s2y2*(af*s2y2-1.))
     &       *(1.+s2z2*(af*s2z2-1.))
          Sd=SAa**2
          if(intl.eq.1)then
           SAe  =  (cx*cy*cz)**3
     &            *(cx+af*sx**2)*(cy+af*sy**2)*(cz+af*sz**2)
           SAe=SAe+(cx*sy*sz)**3
     &            *(cx+af*sx**2)*(sy+af*cy**2)*(sz+af*cz**2)
           SAe=SAe+(sx*cy*sz)**3
     &            *(sx+af*cx**2)*(cy+af*sy**2)*(sz+af*cz**2)
           SAe=SAe+(sx*sy*cz)**3
     &            *(sx+af*cx**2)*(sy+af*cy**2)*(cz+af*sz**2)
           SAo=SAa-SAe
           Sd=SAe**2+SAo**2
          end if
c
          Dkx1=s1x*(1.+c1y+c1z)
          Dky1=s1y*(1.+c1z+c1x)
          Dkz1=s1z*(1.+c1x+c1y)
c
c 10 pt for intl=0, 20pt for intl=1
c
          if(intl.eq.0)then
             Dkx=2.*Dkx1
             Dky=2.*Dky1
             Dkz=2.*Dkz1
          else if(intl.eq.1)then
             Dkx2=s1x*(c1y*c1z/2.+c1x/4.)
             Dky2=s1y*(c1z*c1x/2.+c1y/4.)
             Dkz2=s1z*(c1x*c1y/2.+c1z/4.)
c
             Dkx=8.*(Dkx1+Dkx2)
             Dky=8.*(Dky1+Dky2)
             Dkz=8.*(Dkz1+Dkz2)
          end if
c
          if(igz.eq.Lc .and. igy.eq.Le .and. igx.eq.Le)then
          DWR=0.
          else
          DWR=(SRx*Dkx+SRy*Dky+SRz*Dkz)/(Dkx*Dkx+Dky*Dky+Dkz*Dkz)
          end if
c
          gp3t=sf*DWR/Sd
c
          difft=df*SUM/Sd
c
          fr=1.
          if(igx.eq.1 .or. igx.eq.Lc)fr=fr*2.
          if(igy.eq.1 .or. igy.eq.Lc)fr=fr*2.
          if(igz.eq.1 .or. igz.eq.Lc)fr=fr*2.
          difft=difft/fr
c
         end if
         gp3(igx,igy,igz)=gp3t
         gp3(igx,igz,igy)=gp3t
         gp3(igy,igz,igx)=gp3t
         gp3(igy,igx,igz)=gp3t
         gp3(igz,igx,igy)=gp3t
         gp3(igz,igy,igx)=gp3t
c
         diff(igx,igy,igz)=difft
         diff(igx,igz,igy)=difft
         diff(igy,igz,igx)=difft
         diff(igy,igx,igz)=difft
         diff(igz,igx,igy)=difft
         diff(igz,igy,igx)=difft
400   continue
c
      do 300 iz=1,Lc
       do 300 iy=1,Lc
300   diff(Le,iy,iz)=0.5*diff(Le,iy,iz)
c
      open(11,file=longfile,status='unknown',form='unformatted')
      write(11)L,intl,soft,dpf
      write(11)gp3,diff
      gampo=1.
c
 666  close(11)
c
      end if
c
      if(gamp.ne.gampo)then
c
      gfac=gamp/gampo
      Lc=L/2+1
c
      do 700 iz=1,Lc
       do 700 iy=1,iz
        do 700 ix=1,iy
         gp3t=gp3(ix,iy,iz)*gfac
         gp3(ix,iy,iz)=gp3t
         gp3(ix,iz,iy)=gp3t
         gp3(iy,iz,ix)=gp3t
         gp3(iy,ix,iz)=gp3t
         gp3(iz,ix,iy)=gp3t
         gp3(iz,iy,ix)=gp3t
 700  continue
c
      gampo=gamp
      end if
c
      softo=soft
      Lo=L
c      
      RETURN
      end
c
      SUBROUTINE igreen(sfts,sftl,gamp,intl,L,gi3,difi,gl,Uslf)
c
      dimension gi3((L+1)**3),difi((L+1)**3)
      dimension gl(2*L+1,2*L+1,2*L+1)
c
      include 'iodefs.inc'
      character*60 greenfile,vf,longfile
c
      save Lo,sftso,sftlo,gampo
      data Lo,sftso,sftlo/-1,-1.,-1./
      data dpf/-1./
c     
      if(sfts.ne.sftso .or. sftl.ne.sftlo .or. L.ne.Lo)then
c
      klf=int(log10(float(L)))+1
      ksf=int(log10(sfts))+4
      kslf=int(log10(sftl))+4
c     
      write(vf,'(''(''''igrnL'''',i'',i1,'',''''s'''',f'',i2.2,
     &     ''.2,''''sl'''',f'',i2.2,''.2)'')')klf,ksf,kslf
c
      write(greenfile,vf)L,sfts,sftl
c
      if(intl.eq.1)greenfile=greenfile(1:lnblnk(greenfile))//'I'
c
      longfile='greenfn/'//greenfile
      open(11,file=longfile,status='old',form='unformatted',err=444)
      read(11,err=444)Lf,intlf,sftsf,sftlf
      err=abs(sfts/sftsf-1.)+abs(sftl/sftlf-1.)
      if(err.gt.2.e-3)GOTO 444
      read(11,err=444)Uslf
      call readgreenr(gi3,difi,L,ier)
      if (ier.ne.0) goto 444
      gampo=1.
      GOTO 666
c
 444  close(11,err=445)
 445  continue
c     
      L2=2*L
      L4=4*L
      L2p2=2*L+2
      tpi=6.28318530717959
      tpiL=tpi/float(L2)
c
      df=1./(float((2*L)**3)*8.*(1.+intl))
c
      do 400 iz=1,2*L+1
       do 400 iy=1,iz
         do 400 ix=1,iy
         it2=(ix-1)**2+(iy-1)**2+(iz-1)**2
         rad=0.5*sqrt(float(it2))
         CALL S2(rad,sfts,grav,pot1)
         CALL S2(rad,sftl,grav,pot2)
         gtmp=pot1-pot2
         if(it2.eq.0)Uslf=0.5*gtmp
         gtmp=df*gtmp
         gl(ix,iy,iz)=gtmp
         gl(ix,iz,iy)=gtmp
         gl(iy,iz,ix)=gtmp
         gl(iy,ix,iz)=gtmp
         gl(iz,ix,iy)=gtmp
         gl(iz,iy,ix)=gtmp
400   continue
c
      CALL realevenfft(gl,L4)
c
      af=2./15.
      icount=0
      do 500 ikz=1,L+1
       rkz=tpiL*(ikz-1)
       s1z=sin(rkz)
       c1z=cos(rkz)
       s2z=sin(rkz/2.)
       s2z2=s2z**2
       psz=2.*s2z
       sz=sin(rkz/4.)**2
       cz=1.-sz
       do 500 iky=1,ikz
        rky=tpiL*(iky-1)
        s1y=sin(rky)
        c1y=cos(rky)
        s2y=sin(rky/2.)
        s2y2=s2y**2
        psy=2.*s2y
        sy=sin(rky/4.)**2
        cy=1.-sy
        do 500 ikx=1,iky
         icount=icount+1
         rkx=tpiL*(ikx-1)
         s1x=sin(rkx)
         c1x=cos(rkx)
         s2x=sin(rkx/2.)
         s2x2=s2x**2
         psx=2.*s2x
         sx=sin(rkx/4.)**2
         cx=1.-sx
c
         SRx=0.
         SRy=0.
         SRz=0.
         SUM=0.
         do 501 inz=0,1
          icz=ikz
          if(inz.eq.1)icz=L2p2-ikz
          rkzn=rkz-tpi*inz
          qz=1.
          if(rkzn.ne.0.)qz=psz/rkzn
          do 501 iny=0,1
           icy=iky
           if(iny.eq.1)icy=L2p2-iky
           rkyn=rky-tpi*iny
           qy=1.
           if(rkyn.ne.0.)qy=psy/rkyn
           do 501 inx=0,1
            icx=ikx
            if(inx.eq.1)icx=L2p2-ikx
            rkxn=rkx-tpi*inx
            qx=1.
            if(rkxn.ne.0.)qx=psx/rkxn
c
            st=gl(icx,icy,icz)*(qx*qy*qz)**6
            SUM=SUM+st
            SRx=SRx+rkxn*st
            SRy=SRy+rkyn*st
            SRz=SRz+rkzn*st
 501     continue
c
         SU2=(1.+s2x2*(af*s2x2-1.))
     &      *(1.+s2y2*(af*s2y2-1.))
     &      *(1.+s2z2*(af*s2z2-1.))
c
         Sd=SU2**2
         if(intl.eq.1)then
          SAe  =  (cx*cy*cz)**3
     &           *(cx+af*sx**2)*(cy+af*sy**2)*(cz+af*sz**2)
          SAe=SAe+(cx*sy*sz)**3
     &           *(cx+af*sx**2)*(sy+af*cy**2)*(sz+af*cz**2)
          SAe=SAe+(sx*cy*sz)**3
     &           *(sx+af*cx**2)*(cy+af*sy**2)*(sz+af*cz**2)
          SAe=SAe+(sx*sy*cz)**3
     &           *(sx+af*cx**2)*(sy+af*cy**2)*(cz+af*sz**2)
          SAo=SU2-SAe
          Sd=SAe**2+SAo**2
         end if
c
         Dkx=s1x*(1.+c1y+c1z)
         Dky=s1y*(1.+c1z+c1x)
         Dkz=s1z*(1.+c1x+c1y)
c     
         D2=(Dkx*Dkx+Dky*Dky+Dkz*Dkz)
         gtmp=0.
         if(D2 .ne. 0.)gtmp=(SRx*Dkx+SRy*Dky+SRz*Dkz)/(D2*Sd)
         gtmp=0.5*gtmp
c
         dtmp=SUM/Sd
c
         fr=1.
         if(ikx.eq.1 .or. ikx.eq.L+1)fr=0.5*fr
         if(iky.eq.1 .or. iky.eq.L+1)fr=0.5*fr
         if(ikz.eq.1 .or. ikz.eq.L+1)fr=0.5*fr
         dtmp=fr*dtmp
c
         gi3(icount)=gtmp
         difi(icount)=dtmp
500   continue
c
      open(11,file=longfile,status='unknown',form='unformatted')
      write(11)L,intl,sfts,sftl,dpf
      write(11)Uslf
      call writegreenr(gi3,difi,L,ier)
      gampo=1.
c
 666  close(11)
c
      call cubeexpandr(gi3,difi,L)

      end if
c
      if(gamp.ne.gampo)then
c
      gfac=gamp/gampo
      do i=1,(L+1)**3
         gi3(i)=gi3(i)*gfac
      enddo
c
      gampo=gamp
      end if
c
      sftso=sfts
      sftlo=sftl
      Lo=L
c
      RETURN
      end
c
c-----------------------------------------------------------------------
c
      subroutine readgreenr(gi3,difi,L,ier)
c
      dimension gi3(((L+1)*(L+2)*(L+3))/6)     
      dimension difi(((L+1)*(L+2)*(L+3))/6)
c
      read(11,iostat=ier) gi3,difi
c
      return
      end
c
c----------------------------------------------------------------------
c
      subroutine writegreenr(gi3,difi,L,ier)
c
      dimension gi3(((L+1)*(L+2)*(L+3))/6)     
      dimension difi(((L+1)*(L+2)*(L+3))/6)
c
      write(11,iostat=ier) gi3,difi
c
      return
      end
c
c----------------------------------------------------------------------
c
      subroutine cubeexpandr(gi3,difi,L)
c Expands a 1D representation to a 3D rep in cube/6
c
      real gi3((L+1)**3),difi((L+1)**3)
      L2=(L+1)*(L+1)
c
      i=((L+1)*(L+2)*(L+3))/6
      do 1 iz=(L+1),1,-1
       itz=L2*(iz-1)
       do 1 iy=iz,1,-1
        ity=(L+1)*(iy-1)
        do 1 ix=iy,1,-1
          it=ix+ity+itz
             gi3(it)=gi3(i)
             difi(it)=difi(i)
          i=i-1
 1    continue
c
      call symcuber(gi3,difi,(L+1))
c
      Le=L/2+1
      Lej=(Le-1)*(L+1)**2
      do 600 iy=1,L+1
       do 600 ix=1,L+1
          indx=ix+(iy-1)*(L+1)+Lej
600    difi(indx)=0.5*difi(indx)

      return
      end
c
c----------------------------------------------------------------------
c
      subroutine symcuber(gi3,difi,L)
      real gi3(L,L,L),difi(L,L,L)
c
      do 1 iz=1,L
       do 1 iy=1,iz
        do 1 ix=1,iy
          gt=gi3(ix,iy,iz)
          gi3(iz,ix,iy)=gt
          gi3(iy,iz,ix)=gt
          gi3(iy,ix,iz)=gt
          gi3(ix,iz,iy)=gt
          gi3(iz,iy,ix)=gt
          gt=difi(ix,iy,iz)
          difi(iz,ix,iy)=gt
          difi(iy,iz,ix)=gt
          difi(iy,ix,iz)=gt
          difi(ix,iz,iy)=gt
          difi(iz,iy,ix)=gt
 1    continue
c
      return
      end
c
c *********************************************************************
c
      SUBROUTINE S2(r,a,grav,dpot)
      xi=2.*r/a
      if(xi.ge.0. .and. xi.lt.1.)then
       grav=xi*(224.+xi*xi*(-224.+xi*(70.+xi*(48.-xi*21.))))/35./a**2
       dpot=(208.+xi*xi*(-112.+xi*xi*(56.+xi*(-14.
     &                           +xi*(-8.+xi*3.)))))/70./a
      else if(xi.ge.1. .and. xi.lt.2.)then
       grav=(12./xi**2-224.+xi*(896.+xi*(-840.+xi*(224.+xi*(70.+
     &        xi*(-48.+xi*7.))))))/35./a**2
       dpot=(12./xi+128.+xi*(224.+xi*(-448.+xi*(280.
     &        +xi*(-56.+xi*(-14.+xi*(8.-xi)))))))/70./a
      else 
       grav=1./r**2
       dpot=r*grav
      end if
      RETURN
      end
c
c********************************************************************
c     
      SUBROUTINE errfit(err,intl,ibc,rLa,softm,Ls)
c
c Fits for 10 pt (ibc=0, 1) with TSC for intl=0
c      and 20 pt (ibc=1) and 10 pt (ibc=0) with TSC for intl=1
c
c The fits marked '$$' ( softm=softm(re) ) must be accurate for good matching
      if(intl.eq.0)then
       emesh=0.44*err
       emesh=min(emesh,4.62)
       emesh=max(emesh,1.55)
       at=3.92-sqrt(0.29*emesh-0.425)
c
       if(at .gt. 3.11)then
          ret=-0.146*at**2+2.21*at-3.34
       else if(at .le. 3.11)then
          ret=2.55*at**2-14.54*at+22.703
       end if
       Ls=nint(rLa/ret)
c
       re=rLa/float(Ls)
c $$
       if(re .ge. 2.133)then
          softm=7.594-sqrt(34.742-6.864*re)
       else if(re .lt. 2.133)then
          softm=2.854+sqrt(0.3926*re-0.77165)
       end if
      else if(intl.eq.1)then
       emesh=0.6*err
       if(ibc.eq.0)then
        emesh=min(emesh,3.2)
        emesh=max(emesh,0.73)
        at=3.51-sqrt(0.2*emesh-0.145)
       else if(ibc.eq.1)then
        emesh=min(emesh,2.47)
        emesh=max(emesh,0.37)
        at=3.51-sqrt(0.24*emesh-0.088)
       end if
       ret=-0.8*at**2+6.42*at-9.71
       Ls=nint(rLa/ret)
c
       re=rLa/float(Ls)
c $$
       softm=4.0125-sqrt(3.9625-1.25*re)
      end if
      if(ibc.eq.0)Ls=Ls+2
c
      RETURN
      end
c
c********************************************************************
c
      SUBROUTINE realevenfft(g,L)
      parameter(Lmax=1024)
      real g(L/2+1,L/2+1,L/2+1),work(Lmax)
      double precision tpiN,sr,cr,snr,cnr,tmp
c
      if(L.gt.Lmax)stop 'realevenfft error'
      tpiN=2.*3.14159625/float(L)
      tpiN=6.28318530717959d0/float(L)
      snr=sin(tpiN)
      cnr=-2.0d0*sin(0.5d0*tpiN)**2
c
      L2p1=L/2+1
      do 400 iz=1,L2p1
       do 400 iy=1,L2p1
c
        sr=0.
        cr=1.
        do 401 ix=1,L/2
         igx=L/2+2-ix
         work(2*ix-1)=g(ix,iy,iz)+g(igx,iy,iz)
         work(2*ix)=2.*(g(ix,iy,iz)-g(igx,iy,iz))*cr
         tmp=sr
         sr=sr*cnr+cr*snr+sr
         cr=cr*cnr-tmp*snr+cr
 401    continue
        CALL fourn(work,L/2,1,1)
        Gt=work(2)/2.
        do 402 i=1,L/4
           nr=2*i-1
           ni=nr+1
           g(nr,iy,iz)=work(nr)
           g(ni,iy,iz)=work(ni)-Gt
           Gt=g(ni,iy,iz)
 402    continue
        g(L/2+1,iy,iz)=work(L/2+1)
 400  continue
c
      do 500 iz=1,L2p1
       do 500 ix=1,L2p1
c
        sr=0.
        cr=1.
        do 501 iy=1,L/2
         igy=L/2+2-iy
         work(2*iy-1)=g(ix,iy,iz)+g(ix,igy,iz)
         work(2*iy)=2.*(g(ix,iy,iz)-g(ix,igy,iz))*cr
         tmp=sr
         sr=sr*cnr+cr*snr+sr
         cr=cr*cnr-tmp*snr+cr
 501    continue
        CALL fourn(work,L/2,1,1)
        Gt=work(2)/2.
        do 502 i=1,L/4
           nr=2*i-1
           ni=nr+1
           g(ix,nr,iz)=work(nr)
           g(ix,ni,iz)=work(ni)-Gt
           Gt=g(ix,ni,iz)
 502    continue
        g(ix,L/2+1,iz)=work(L/2+1)
 500  continue
c
      do 600 iy=1,L2p1
       do 600 ix=1,L2p1
c
        sr=0.
        cr=1.
        do 601 iz=1,L/2
         igz=L/2+2-iz
         work(2*iz-1)=g(ix,iy,iz)+g(ix,iy,igz)
         work(2*iz)=2.*(g(ix,iy,iz)-g(ix,iy,igz))*cr
         tmp=sr
         sr=sr*cnr+cr*snr+sr
         cr=cr*cnr-tmp*snr+cr
 601    continue
        CALL fourn(work,L/2,1,1)
        Gt=work(2)/2.
        do 602 i=1,L/4
           nr=2*i-1
           ni=nr+1
           g(ix,iy,nr)=work(nr)
           g(ix,iy,ni)=work(ni)-Gt
           Gt=g(ix,iy,ni)
 602    continue
        g(ix,iy,L/2+1)=work(L/2+1)
 600  continue
c
      RETURN
      end
c
c********************************************************************
c
      SUBROUTINE FOURN(DATA,NN,NDIM,ISIGN)
      DOUBLE PRECISION WR,WI,WPR,WPI,WTEMP,THETA
      DIMENSION NN(NDIM),DATA(*)
      NTOT=1
      DO 11 IDIM=1,NDIM
        NTOT=NTOT*NN(IDIM)
   11 CONTINUE
      NPREV=1
      DO 18 IDIM=1,NDIM
        N=NN(IDIM)
        NREM=NTOT/(N*NPREV)
        IP1=2*NPREV
        IP2=IP1*N
        IP3=IP2*NREM
        I2REV=1
        DO 14 I2=1,IP2,IP1
          IF (I2.LT.I2REV) THEN
            DO 13 I1=I2,I2+IP1-2,2
              DO 12 I3=I1,IP3,IP2
                I3REV=I2REV+I3-I2
                TEMPR=DATA(I3)
                TEMPI=DATA(I3+1)
                DATA(I3)=DATA(I3REV)
                DATA(I3+1)=DATA(I3REV+1)
                DATA(I3REV)=TEMPR
                DATA(I3REV+1)=TEMPI
   12         CONTINUE
   13       CONTINUE
          ENDIF
          IBIT=IP2/2
    1     IF ((IBIT.GE.IP1) .AND. (I2REV.GT.IBIT)) THEN
            I2REV=I2REV-IBIT
            IBIT=IBIT/2
            GO TO 1
          ENDIF
        I2REV=I2REV+IBIT
   14   CONTINUE
        IFP1=IP1
    2   IF (IFP1.LT.IP2) THEN
          IFP2=2*IFP1
          THETA=ISIGN*6.28318530717959D0/(IFP2/IP1)
          WPR=-2.D0*SIN(0.5D0*THETA)**2
          WPI=SIN(THETA)
          WR=1.D0
          WI=0.D0
          DO 17 I3=1,IFP1,IP1
            DO 16 I1=I3,I3+IP1-2,2
              DO 15 I2=I1,IP3,IFP2
                K1=I2
                K2=K1+IFP1
                TEMPR=WR*DATA(K2)-WI*DATA(K2+1)
                TEMPI=WR*DATA(K2+1)+WI*DATA(K2)
                DATA(K2)=DATA(K1)-TEMPR
                DATA(K2+1)=DATA(K1+1)-TEMPI
                DATA(K1)=DATA(K1)+TEMPR
                DATA(K1+1)=DATA(K1+1)+TEMPI
   15         CONTINUE
   16       CONTINUE
            WTEMP=WR
            WR=WR*WPR-WI*WPI+WR
            WI=WI*WPR+WTEMP*WPI+WI
   17     CONTINUE
          IFP1=IFP2
          GO TO 2
        ENDIF
        NPREV=N*NPREV
   18 CONTINUE
      RETURN
      END
c
c *********************************************************************
c
      FUNCTION RAN3(IDUM)
      SAVE
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1.E-9)
      DIMENSION MA(55)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
        IFF=1
        MJ=MSEED-IABS(IDUM)
        MJ=MOD(MJ,MBIG)
        MA(55)=MJ
        MK=1
        DO 11 I=1,54
          II=MOD(21*I,55)
          MA(II)=MK
          MK=MJ-MK
          IF(MK.LT.MZ)MK=MK+MBIG
          MJ=MA(II)
11      CONTINUE
        DO 13 K=1,4
          DO 12 I=1,55
            MA(I)=MA(I)-MA(1+MOD(I+30,55))
            IF(MA(I).LT.MZ)MA(I)=MA(I)+MBIG
12        CONTINUE
13      CONTINUE
        INEXT=0
        INEXTP=31
        IDUM=1
      ENDIF
      INEXT=INEXT+1
      IF(INEXT.EQ.56)INEXT=1
      INEXTP=INEXTP+1
      IF(INEXTP.EQ.56)INEXTP=1
      MJ=MA(INEXT)-MA(INEXTP)
      IF(MJ.LT.MZ)MJ=MJ+MBIG
      MA(INEXT)=MJ
      RAN3=MJ*FAC
      RETURN
      END
