      SUBROUTINE list(N,r,itype,ll,Ls,ihc,nhc,rca,rcb)
c
c  Create a linked list of particles in chaining cells
c
      include 'psize.inc'
      include 'itype.inc'
c
      real r(3,N)
      integer ihc(Ls**3),nhc(Ls**3),ll(N),itype(N)
      integer itab(0:Lsmax+1)
      parameter (nppmax=50000)
      integer boxlist(nppmax),indx(nppmax)
      real    zcoord (nppmax)
c
      Ls3=Ls**3
      Ls2=Ls**2
c
      do i=1,Ls3
         ihc(i)=0
         nhc(i)=0
      enddo
c
      do i=1,N
         ll(i)=0
      enddo
c
      itab(0)=0
      do i=1,Ls
         itab(i)=i-1
      end do
      itab(Ls+1)=Ls-1
c
      do i=1,N
         if (itype(i).ne.itnone) then
            rx=rca*r(1,i)+rcb
            ry=rca*r(2,i)+rcb
            r3i=r(3,i)
            rz=rca* r3i + rcb
            ix= itab(int(rx))
            iy= itab(int(ry))
            iz= itab(int(rz))
            ibox=1+ix+Ls*iy+Ls2*iz
            nhc(ibox)=nhc(ibox)+1
c
            ll(i)=ihc(ibox)
            ihc(ibox)=i
         end if
      enddo
c
      do ibox=1,Ls**3
         i  = ihc(ibox)
         np = nhc(ibox)
	 if(np.gt.1)then
            if (np.gt.nppmax) then
               write(*,*) 'STOP list: np.gt.nppmax ',np,nppmax
               stop
            endif
            do ip=1,np
               boxlist (ip) = i
               zcoord  (ip) = r(3,i)
               i            = ll(i)
            enddo
c     sort these particles in increasing zcoord
            call rindexx(np,zcoord,indx)
c     and re-load linked list, ihc(ibox) is particle with largest z
            ll(boxlist(indx(1))) = 0 ! particle with smallest z
            do ip=2,np
               jp = boxlist(indx(ip))
               lp = boxlist(indx(ip-1))
               ll(jp) = lp
            enddo
            ihc(ibox) = boxlist(indx(np)) ! particle with largest z
         endif
      enddo

      RETURN
      end

c----------------------------------------------------------------------
      SUBROUTINE rindexx(n,arr,indx)
      INTEGER n,indx(n),M,NSTACK
      REAL arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      REAL a
      do 11 j=1,n
        indx(j)=j
11    continue
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 13 j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do 12 i=j-1,1,-1
            if(arr(indx(i)).le.a)goto 2
            indx(i+1)=indx(i)
12        continue
          i=0
2         indx(i+1)=indxt
13      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if(arr(indx(l+1)).gt.arr(indx(ir)))then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(ir)))then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l+1)).gt.arr(indx(l)))then
          itemp=indx(l+1)
          indx(l+1)=indx(l)
          indx(l)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l)
        a=arr(indxt)
3       continue
          i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
          j=j-1
        if(arr(indx(j)).gt.a)goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       indx(l)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in indexx'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END



