      SUBROUTINE lostp(nobj,ilp,rm,r,v,e,itype,soft,rmnorm0,atime,
     &     Tlost,Qlost,dUlost)
c
c  Calculates the energy lost be a particle that strays over the box
c  boundary and sets its itype to itnone.
c  Note that atime is not really needed as it should be unity.
c  dUlost (the change in Ulost) is returned rather than Ulost as dUlost
c  may need to be subtracted from the PE calculated in accel.
c
      INCLUDE 'itype.inc'
c
      integer i,j,ilp,itype(nobj)
      real r(3,nobj),v(3),rm(nobj),e
c
      soft2=(soft/2.34)**2
      up=0.
      do 202 i=1,nobj
         if (i.eq.ilp .or. itype(i).eq.itnone) goto 202
         rsq=0.
         do j=1,3
            rsq=rsq+(r(j,ilp)-r(j,i))**2
         enddo
c  Full S2-shaped potential
         rad=sqrt(rsq)
         up=up+rm(i)*S2pot(rad,soft)
c  Plummer approximation may be quicker
c         up=up+rm(i)/sqrt(soft2+rsq)
202    continue
       up=up*rm(ilp)
       Tp=0.
       do j=1,3
          Tp=Tp+rm(ilp)*v(j)**2
       enddo
c
       Tlost=Tlost+Tp/2.
       dUlost=up*rmnorm0/atime
       Qlost=Qlost+e*rm(ilp)
c
       itype(ilp)=itnone
c
      RETURN
      end
c-------------------------------------------------------------------
      real function S2pot(r,a)
c
      xi=2.*r/a
      if(xi.ge.0. .and. xi.lt.1.)then
       S2pot=(208.+xi*xi*(-112.+xi*xi*(56.+xi*(-14.
     &                           +xi*(-8.+xi*3.)))))/70./a
      else if(xi.ge.1. .and. xi.lt.2.)then
       S2pot=(12./xi+128.+xi*(224.+xi*(-448.+xi*(280.
     &        +xi*(-56.+xi*(-14.+xi*(8.-xi)))))))/70./a
      else 
       S2pot=1./r
      end if
c
      RETURN
      end
      
