c  commonly used parameters which it would be tedious to pass explicitly
      common/param/itime,itstop,itdump,itout,  time,atime,htime,dtime,
     &             Est,T,Th,U,               Radiation,Esum,Rsum,cputo,
     &             tstop,tout,icdump,pad1,     Tlost,Qlost,Ulost,pad2,
     &		   soft,dta,dtcs,dtv
      common/start/irun,nobj,ngas,ndark,       intl,nlmx,perr,dtnorm,
     &             sft0,sftmin,sftmax,pad3,    h100,box100,zmet0,lcool,
     &             rmbary,rmtot,rmnorm0,omegab0,
     &		                           tstart,omega0,xlambda0,h0t0,
     &             rcen,rmax2
      parameter(icdumpmax=200)
      common/outputtime/tout1
      real tout1(icdumpmax),rcen(3)
      integer ibuf1(100),ibuf2(100),ibuf(icdumpmax)
      equivalence (ibuf1,itime),(ibuf2,irun),(ibuf,tout1)
c
c  itime - timestep #
c  itstop - timestep to stop at
c  itdump - dump (ie backup) every itdump timesteps
c  itout - next timestep to output results at
c  time - simulation time 
c  atime - expansion factor 
c  htime - Hubble parameter 
c  dtime - current timestep 
c  Est - start energy
c  T - kinetic energy
c  Th - thermal energy
c  U - potential energy
c  Radiation - radiated energy
c  Esum - energy integral
c  Rsum - total radiated energy
c  cputo - cputime
c  tstop - time to stop at
c  tout - next time to output results at
c  icdump1 - index of list of requested output times, tout1
c  Tlost - kinetic energy of escaping particles
c  Qlost - thermal energy of escaping particles
c  Ulost - potential energy of escaping particles
c  soft2 - current Plummer softening squared
c  dta - minimum timestepfrom acceleration
c  dtcs - minimum timestep from sound speed
c  dtv - minimum timestep from velocity
c  irun - run #
c  nobj - total number of particles
c  ngas - number of gas particles (MUST BE FIRST IN LIST)
c  ndark - number of dark matter particles
c  L - top level FFT grid size
c  intl - must be 0 (1 for interlacing)
c  nlmx - maximum number of refinement levels
c  perr - percentage error for gravity (roughly) --- use 7.7 or 2.0
c  dtnorm - multiplier for timestep --- use 1 unless particles go haywire
c  sft0 - z=0 softening
c  sftmin,sftmax - minimum and maximum softening
c  h100 - Hubble parameter in units of 100 km/s/Mpc
c  box100 - z=0 boxsize in Mpc/h100
c  zmet0 - metallicity of gas relative to solar, if constant
c  lcool - cooling switch (1=on)
c  rmbary - baryonic particle mass (grid units)
c  rmnorm0 - intermediate in normalisation of gravity force
c  tstart - time of initial conditions
c  omegab0 - z=0 value of omegab
c  omega0 - z=0 value of omega
c  xlambda0 - z=0 value of lambda
c  h0t0 - z=0 value of Hubble parameter times age of universe
c  rcen - middle of the box in input co-ordinates
c  rmax2 - square of maximum distance from centre in isolated simulations
c  tout1 - list of desired output times
