c
c  Nmax = maximum number of particles
c  Nmaxgas = maximum number of gas particles
c  Lmax = maximum PM grid size
c  Lgmax = maximum SPH grid size (and also grid size for darkdens)
c  maxtree = size of tree for catalogue generation (not required for hydra)
c
c  Nmax is usually the cube of a power-of-two (dm-only) or twice this (dm+gas)
      parameter(Nmax=2*16**3,Nmaxgas=Nmax/2)
c
c  Lmax should usually be set to twice the cube-root of the number of
c  dm particles.  It must be a power of 2.
      parameter(Lmax=32)
c
c  Lgmax should be roughly equal to Lmax, but can be made larger for
c  highly-clustered simulations.  It need not be a power of 2.
      parameter(Lgmax=32)
c
c  maxtree varies depending upon the density cut-off for tree
c  formation.  At worst it needs to be equal to the total number of
c  particles of the type used to grow the tree.
c  maxtree is not used by hydra.
      parameter(maxtree=1.5*12**3,maxtop=2*maxtree,maxgroup=maxtree/4)
c
c   *** You should not need to change anything below here ***
c   *** unless your compiler does not support the use of  ***
c   *** max in parameter statements                       ***
c
c  Maximum Nmax and Lmax in refinements
      parameter(Npmax=Nmax,Lpmax=Lmax)
c  Maximum refinement nesting level
      parameter(nlmxmax=6)
c  Size of force lookup table
      parameter(ntp=30000)
c
      parameter(Lsmx1=Lmax/2,Lsmx2=Lpmax/2+2)
c      parameter(Lsmax=max(Lsmx1,Lsmx2))
c  linux hack (inefficient)
      parameter(Lsmax=Lsmx1+Lsmx2)
c
      parameter(Lmax3=Lmax**3,Lmaxc=Lmax/2+1,Lmaxc3=Lmaxc**3)
      parameter(Lsmax3=Lsmax**3)
      parameter(Lpmax13=(Lpmax+1)**3)
c
      parameter(tpi=6.283185307179d0,pi=tpi/2.)
c
      parameter(Nw1=2*Lmax3,Nw2=Nmax+(2*Lpmax+1)**3,
     x                            Nw3=Nmax+2*Lsmax**3+Npmax)
c
c      parameter(Ntmp=max(Nw1,Nw2))
c      parameter(Nwrk=max(Ntmp,Nw3))
c  linux hack (inefficient)
      parameter(Nwrk=Nw1+Nw2+Nw3)
c
      parameter(nbit=32,maxin1=2**(nbit-2),maxint=2*(maxin1-1)+1)
c
c **********************************************
c
c    Standard:
c 
c          Both meshes; 10pt differencing
c                       TSC assignment
c
c
c     One body centered interlace:
c
c          Periodic mesh; 20 pt differencing
c                         TSC assignment
c
c          Isolated mesh; 10 pt differencing
c                         TSC assignment
c
c
c 32^3=32768, 64^3=262144, 128^3=2097152
c
