      SUBROUTINE readparam
c
c  reads control parameters and warns of changes
c
      include 'psize.inc'
      include 'pinfo.inc'
c
      read(55,*) irunnew
      read(55,*) itstop,itdump
      read(55,*) dtnormnew
      read(55,*) sft100
      read(55,*) nlmxnew
c
      if(irunnew.ne.irun)print*,'*** Warning irun changed ***'
      irun=irunnew
      write(*,*) 'irun=',irun
c
      if(dtnormnew.ne.dtnorm)print*,'*** Warning dtnorm changed ***'
      dtnorm=dtnormnew
      write(*,*) 'dtnorm=',dtnorm
c
c  convert physical softening to code units (S2=2.34*Plummer)
#ifndef NOEXPAND
      sft0new=sft100/box100*2.34
#else
      sft0new=sft100*2.34
#endif
      if(sft0new.ne.sft0)print*,'** Warning sft0 changed **'
      sft0=sft0new
      write(*,*) 'sft0=',sft0
#ifdef COMOVING
      write(*,*) 'Setting co-moving softening, sftmax=sftmin=sft'	
      sftmax=sft0
#else
c  maximum softening should be 0.3 of FFT grid 
c   this used to be done here---now moved to grav.F
      sftmax=1.e30
#endif
c      sftmin=sft0
            sftmin=0.
c
c  maximum percentage error in force, can vary in range 3.5 to 10.
c  set to <3.5 if you want very high force accuracy.
      perr=7.7
c
c  interlacing switch (only 0 is guaranteed to work)
      intl=0
c
#ifndef NOSPH
#ifdef COOL
c  switch cooling on if necessary
      if (lcool.ne.1) then
         print*,'** Warning: switching cooling on **'
         lcool=1
      end if
#endif
#ifdef NOCOOL
c  switch off cooling if necessary
      if (lcool.ne.0) then
         print*,'** Warning: switching off cooling **'
         lcool=0
      end if
#endif
#endif
c
c  refinement switch
      if (nlmxnew.le.0) then
	print*,'Refinements off'
	nlmx=0
      else	
	print*,'Refinements on'
        nlmx=nlmxmax
      endif	
c
      RETURN
      end
