      SUBROUTINE refforce(N,rm,r,a,itype,ll,L,Ls,ihc,nhc,itag,rf,srf,
     &   rsa,rsb,softm,ibc,U,err,intl,nlmx,soft,rmnorm,Nlins,psf,mp,ip)
c
c  Does PM gravity, calls list and refine to select refinements to
c  exclude from short-range calculation, then calls shforce and
c  shgrav to do short-range accels on remaining particles
c
      include 'psize.inc'
      include 'refparam.inc'
c
      real rm(N),r(3,N),a(3,N)
      integer ll(N),ihc(Ls**3),nhc(Ls**3),itag(Ls**3),itype(N)
      real G(0:ntp+1),D(0:ntp+1)
c
      real gp3(Lmaxc3),diff(Lmaxc3)
      real d3(Lmax3),frc(Lmax3)
c
      real gi3(Lpmax13),difi(Lpmax13),gl((2*Lpmax+1)**3)
      real di3(Lpmax13),frci(Lpmax13),dt(2*Lpmax13)
      equivalence (dt,di3),(dt(Lpmax13+1),frci)
c
      common /wrk/ work(Nwrk)
      equivalence (work,d3),(work(Lmax3+1),frc)
      equivalence (work(Nmax+1),gl),(work(Nmax+1),dt)
c
      save gp3,diff,gi3,difi,G,D,spc0,rmgas,rmdark,Uslf,dptlgas,dptldark
      data spc0/-2/
c
c  On first call, estimate the dptl correction to U
      if (spc0.eq.-2) CALL dptlinit(N,rm,itype,L,ibc,spc0,rmdark,rmgas)
c  correction required only if top-level
      if (ibc.eq.0) then
         spc=-1
      else
         spc=spc0
      end if
c
      Ut=0
      re=1./rsa
      softR=rf*soft
      sft=max(softR,softm)
      gamp=rmnorm*rf**3
c
      if (ibc.eq.1) then
         cpuPMin=cputime()
         CALL green(sft,gamp,intl,L,gp3,diff)
         CALL mesh(Ut,intl,N,itype,rm,r,a,L,gp3,diff,d3,frc)
         cpuPMout=cputime()
#ifdef CPUTIME
         print*,'cputime PM       = ',cpuPMout-cpuPMin
#endif
      else if (ibc.eq.0) then
         sftl=rf*srf
         if (sft.lt.sftl) then
            CALL igreen(sft,sftl,gamp,intl,L,gi3,difi,gl,Uslf)
            CALL imesh(Ut,Uslf,intl,N,itype,rm,r,a,
     &           L,gi3,difi,dt,di3,frci)
         endif
      end if
      Umsh=Ut*rf
c
c  We have to zero itag in case the next condition fails 
c  and refine is not called.
      do i=1,Ls**3
         itag(i)=0
      end do
c  Only need to do PP gravity if true softening is less than PM softening
      if (softR.lt.softm) then
         CALL list(N,r,itype,ll,Ls,ihc,nhc,rsa,rsb)
         CALL refine(N,Ls,ihc,nhc,itag,ibc,err,intl,nlmx,nlv,
     &        Nlins,psf,mp,ip)
         CALL shforce(softR,sft,gamp,re,spc,rmdark,rmgas,
     &        ntp,G,D,dptlgas,dptldark)
         CALL shgrav(N,itype,rm,r,a,L,Ls,ll,ihc,itag,
     &        re,rf,softR,ntp,G,D,dptlgas,dptldark,Ut)
      end if
c
      Udct=Ut*rf-Umsh
      U=U+Ut*rf
c
      RETURN
      end
c----------------------------------------------------------------
c
      SUBROUTINE dptlinit(N,rm,itype,L,ibc,spc0,rmdark,rmgas)
c
c  dptl correction.  This is an attempt to remove the PP component of the
c  grav PE calculation for a smooth distribution.  It assumes that both the
c  gas and dark matter particles are equal mass and on a uniform lattice 
c  (within each species).
c  The PE correction is done on a particle by particle basis rather than
c  being subtracted off all in one go at the end because of rounding error.
c
      include 'itype.inc'
c
      integer itype(N)
      real rm(N)
c
c  correction not required if isolated (ibc=0 on first call)
      if (ibc.eq.0) then
         spc0=-1
      else
c  if a perfect cube
         cuberootN=float(N)**(1./3.)
         Ncuberoot=nint(cuberootN)
         if (N.eq.Ncuberoot**3) then
            i=1
            do while (itype(i).eq.itnone)
               i=i+1
            end do
            if (itype(i).eq.itdark) then
               rmgas=0.
               rmdark=rm(i)
            else
               rmgas=rm(i)
               rmdark=0.
            end if
            spc0=float(L)/cuberootN
         end if
c  if twice a perfect cube
         cuberootN=float(N/2)**(1./3.)
         Ncuberoot=nint(cuberootN)
         if (N.eq.2*Ncuberoot**3) then
            i=1
            do while (itype(i).eq.itnone)
               i=i+1
            end do
            rmgas=rm(i)
            i=N/2+1
            do while (itype(i).eq.itnone)
               i=i+1
            end do
            rmdark=rm(i)
            spc0=float(L)/cuberootN
         end if
c  or else failed
         if (spc0.eq.-2) then
            print*,'unable to do dptl correction'
            spc0=-1
         end if
      end if
c
      RETURN
      end
