      SUBROUTINE rfinit(N,ibc,L,perr,intl,rmin,rsize,
     &     Ls,rf,srf,rffta,rfftb,rsa,rsb,err,softm,Nlins,psf)
c
c  Initialise refinement information
c
      include 'psize.inc'
      include 'refparam.inc'
c
      real rmin(3),rfftb(3)
c
      if (ibc.eq.0) then
         Lsoff=1
         CALL irim(rim)
         rimt=2.*rim+0.5*intl
      else if (ibc.eq.1) then
         Lsoff=0
         rim=0.
         rimt=0.
      end if
      rLa=float(L)-rimt
c
      CALL errfit(err,intl,ibc,rLa,softm,Ls)
      if (Ls.gt.Lsmax) STOP 'rfinit: Ls > Lsmax'
c
c  scaling parameters for PM grid
c  the particle data gets scaled into [1+rim,1+L-(rimt-rim)]
      rffta=rLa/rsize
      do j=1,3
         rfftb(j)=1.+rim-rmin(j)*rffta
      end do
c  scaling parameters from PM to PP (search) grid
c  the particle data gets scaled into [1+Lsoff,1+Ls-Lsoff]
      rsa=float(Ls-2*Lsoff)/rLa
      rsb=1.+Lsoff-(1.+rim)*rsa
c  refinement parameters for refinement 0
      rf=1.
      srf=1000.*L
      NLins(1,0)=N
      NLins(2,0)=L
      NLins(3,0)=-1
      Nlins(4,0)=1
      psf(1,0)=1.
      psf(2,0)=1.
      psf(3,0)=1.
      psf(4,0)=float(L)
      psf(5,0)=softm
c
      RETURN
      end


