      SUBROUTINE shgrav(N,itype,rm,r,a,L,Ls,ll,ihc,itag,
     &    re,rf,sfts,ntpp,G,D,dptlgas,dptldark,U,dtime)
c
c  PP gravity
c
      include 'psize.inc'
      include 'itype.inc'
c
      integer ihc(Ls,Ls,Ls),itag(Ls,Ls,Ls),ll(N)
      integer itype(N)
      real rm(N),r(3,N),a(3,N)
c
c  force evaluation
      real G(0:ntpp+1),D(0:ntpp+1)
      real appg(3),rpp(3),dr(3)
c
c  accounting
      integer jnbox(-1:1,-1:1,-1:1),nbref(-1:1,-1:1,-1:1)
      real radd(0:Lsmax+1),rxadd(-1:1),ryadd(-1:1),rzadd(-1:1)
      integer indx(0:Lsmax+1),inx(-1:1),iny(-1:1),inz(-1:1)
      integer icount(itlow:ithigh)
c
      if(Ls.gt.Lsmax)stop 'shgravsph: Ls>Lsmax'
      if (((re/sfts)**2).gt.ntp) STOP 'softening too small for ntp'
c
      rL=float(L)
      re2=re**2
      delrad2=re2/float(ntpp)
      delin=1./delrad2
c
c  set up wrapping
      radd(0)=-rL
      indx(0)=Ls
      do i=1,Ls
         radd(i)=0.
         indx(i)=i
      enddo
      radd(Ls+1)=rL
      indx(Ls+1)=1
c
      Us=0.
c
c  Initialise diagnostic counters
      do i=itlow,ithigh
         icount(i)=0
      enddo
c
c  loop over central boxes ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      do ibz=1,Ls
         do iby=1,Ls
            do ibx=1,Ls
c
c  do wrapping
      do i=-1,1
         rxadd(i)=radd(ibx+i)
         ryadd(i)=radd(iby+i)
         rzadd(i)=radd(ibz+i)
         inx(i)=indx(ibx+i)
         iny(i)=indx(iby+i)
         inz(i)=indx(ibz+i)
      end do
c
c  loop over neighbouring boxes setting up temporary linked lists
      nb=0
      ibrf=itag(ibx,iby,ibz)
      do nbz=-1,0
         do nby=-1,1
            do nbx=-1,1
               nb=nb+1
               if (nb.lt.15) then
                  nbrf=itag(inx(nbx),iny(nby),inz(nbz))
                  nbref(nbx,nby,nbz)=nbrf
                  jnbox(nbx,nby,nbz)=ihc(inx(nbx),iny(nby),inz(nbz))
               endif
            enddo
         enddo
      enddo
c
c  Loop over particles in central box --------------------------------
      i=jnbox(0,0,0)
      do while (i.gt.0)
         icount(itype(i))=icount(itype(i))+1
         rpp(1)=r(1,i)
         rpp(2)=r(2,i)
         rpp(3)=r(3,i)
c
c  Initialise variables
c  first subtract smooth PE contribution
         if (itype(i).eq.itdark) then
            Ustmp=-0.5*dptldark
         else
            Ustmp=-0.5*dptlgas
         end if
         appg(1) = 0.
         appg(2) = 0.
         appg(3) = 0.
c     
c  Loop over neighbour boxes =========================================
c  Note: if i is in a refinement then we may be able to save time
c  by limiting the number of boxes searched.  We already know much
c  of the necessary information
c     
         nb=0
         rmi=rm(i)
         do nbz=-1,0
            r3i=rpp(3)-rzadd(nbz)
            do nby=-1,1
               r2i=rpp(2)-ryadd(nby)
               do nbx=-1,1
                  r1i=rpp(1)-rxadd(nbx)
                  nb=nb+1
                  if (nb.lt.15) then
                     nbrf=nbref(nbx,nby,nbz)
c     
c  do gravity unless both boxes are in the same refinement
                     if(ibrf.ne.nbrf .or. ibrf.eq.0) then
c
c  loop over particles in box +++++++++++++++++++++++++++++++++++
                        j=jnbox(nbx,nby,nbz)
                        do while (j.gt.0)
                           if (j.eq.i) goto 705
                           dr(3)=r(3,j)-r3i
                           if(-dr(3).gt.re)GOTO 705
                           if(dr(3).gt.re)GOTO 706
                           dr(2)=r(2,j)-r2i
                           dr(1)=r(1,j)-r1i
                           rad2=dr(1)*dr(1)+dr(2)*dr(2)+dr(3)*dr(3)
                           if(rad2 .lt. re2) then
                              rmj=rm(j)
                              grc=rad2*delin
                              igrc=int(grc)
                              gfrac=grc-igrc
                              Gr=G(igrc)+(G(igrc+1)-G(igrc))*gfrac
                Ustmp=Ustmp+rmj*(D(igrc)+(D(igrc+1)-D(igrc))*gfrac)
                              Gro=Gr*rmi
                              a(1,j)=a(1,j)-dr(1)*Gro
                              a(2,j)=a(2,j)-dr(2)*Gro
                              a(3,j)=a(3,j)-dr(3)*Gro
                              Gr=Gr*rmj
                              appg(1)=appg(1)+dr(1)*Gr
                              appg(2)=appg(2)+dr(2)*Gr
                              appg(3)=appg(3)+dr(3)*Gr
                           endif
 706                       continue
                           j=ll(j)
                        enddo
                     endif
                  endif
c  finished box ++++++++++++++++++++++++++++++++++++++++++++++++++
c
 705              continue
               enddo
            enddo
         enddo
c  finished neighbour boxes ======================================
c
         Us=Us+rmi*Ustmp
         a(1,i)=a(1,i)+appg(1)
         a(2,i)=a(2,i)+appg(2)
         a(3,i)=a(3,i)+appg(3)
c
         i=ll(i)
      enddo 
c finished loop over particles in central box -------------------------
c
            enddo
         enddo
      enddo
c finished loop over boxes ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
c
      U=U+Us
c
#ifdef VERBOSE
      print*,'   particle count: ',(icount(i),i=itlow,ithigh)
#endif
c
      RETURN
      end
