      PROGRAM darkdens
c  Works out the density of the dark matter.
c  The i/o routine can be modified to work with a range of styles.
c  The routine assumes that all particles have the same mass - I 
c  am not sure that this is really necessary.
c
      include 'psize.inc'
#include "rvarrays.inc"
      include 'pinfo.inc'
      include 'iodefs.inc'
      include 'itype.inc'
c
      print*,'Which datafile?'
      read(*,'(a)') datafile
      CALL readdata
      print*,'nobj, ngas, ndark = ',nobj,ngas,ndark
      if (nobj.ne.ngas+ndark) STOP 'darkdens: nobj!=ngas+ndark'
      if (nobj.gt.nmaxgas) STOP 'darkdens: nobj>nmaxgas'
c
#ifdef REDO
      if (ngas.eq.nobj) then
         print*,'Forcing re-evaluation of dark matter densities'
         ngas=nobj/2
         ndark=ngas
      end if
#endif
c  Initialise h(i) to -1 to signify that particle is not yet processed
c  and set itype to itgas to fool listg
      do i=ngas+1,nobj
         if (itype(i).ne.itnone) then
            h(i)=-1.
            itype(i)=itgas
         end if
      end do
c
c  Call neighbour-finding routine
      print*,'Starting search for neighbours.'
      CALL grid(ndark,itype(ngas+1),r(1,ngas+1),v(1,ngas+1),
     &                h(ngas+1),e(ngas+1),dn(ngas+1))
c
c  Reset itype, normalise density and check for unprocessed particles
      nlow=0
      do i=ngas+1,nobj
         if (itype(i).ne.itnone) then
            itype(i)=0
            if (h(i).le.0.) then
               nlow=nlow+1
               h(i)=1.
               dn(i)=0.
               e(i)=0.
            else
#ifdef NOEXPAND
               dn(i)=dn(i)*rm(i)
#else
               dn(i)=dn(i)/float(ndark)
#endif
            end if
         end if
      end do
      if (nlow.gt.0) print*,nlow,' unprocessed particles'
c
c  write out
c  need to reset ngas to fool i/o routines into reading data for dm
      ngas=nobj
      ndark=0
      CALL dumpdata
c
      end
