      SUBROUTINE dumpdata
c
c  Dumps data to a file
c
      include 'psize.inc'
#include "rvarrays.inc"
      include 'pinfo.inc'
      include 'iodefs.inc'
      include 'version.inc'
#ifdef BYTE_SWAP
      character longfile_swap*60,longfile*65
#else
      character longfile*60
#endif
#ifdef SAVE_ACCEL
      logical save_accel
#endif

#ifdef BYTE_SWAP
      longfile_swap='data/'//datafile
      longfile=longfile_swap(1:lnblnk(longfile_swap))//'_swap'
#else
      longfile='data/'//datafile
#endif
      open(3,file=longfile,status='unknown',form='unformatted',
     &     iostat=ier)
      if (ier.ne.0) then
         print*,'Error opening ',longfile
         STOP 
      end if

#ifdef SAVE_ACCEL
      save_accel = .false.
      if(datafile(7:10).eq.'back'.or.datafile(7:10).eq.'data')
     &     save_accel=.true.
#endif

c  write version number
      write(3) version0,version1,version2
c
c  write header
      write(3) ibuf,ibuf1,ibuf2
c
c  Have to write data in separate calls otherwise too slow
      CALL write_itype(nobj,itype)
      CALL write_scalar(nobj,rm)
      CALL write_vector(nobj,r)
      CALL write_vector(nobj,v)
#ifndef NOSPH
      if (ngas.gt.0) then
         CALL write_scalar(ngas,h)
         CALL write_scalar(ngas,e)
         CALL write_scalar(ngas,dn)
#ifdef ZMET
         CALL write_scalar(ngas,zmet)
#endif
#ifdef SAVESTAR
         if (itime.gt.0 .and. lcool.eq.1) then
            CALL write_scalar(ngas,startime)
            CALL write_itype(ngas,galindex)
         end if
#endif
      end if
#endif

#ifdef SAVE_ACCEL
      if(save_accel) CALL write_vector(nobj,a)
#ifndef NOSPH
      if (save_accel .and. ngas.gt.0) CALL write_scalar(ngas,de)
#ifdef ENTROPY
      if (save_accel .and. ngas.gt.0) CALL write_scalar(ngas,ds)
#endif
#endif
#endif
      close(3)

#ifdef BYTE_SWAP
      CALL byte_swap(longfile(1:lnblnk(longfile)),
     &          longfile_swap(1:lnblnk(longfile_swap)))
      CALL rm_sys(longfile(1:lnblnk(longfile)))
#endif

      RETURN
      end

c---------------------------------------------------------------
      SUBROUTINE write_scalar(n,s)
      real*4 s(n)
      write(3) s
      RETURN
      end

c---------------------------------------------------------------
      SUBROUTINE write_vector(n,s)
      real*4 s(3,n)
      write(3) s
      RETURN
      end

c---------------------------------------------------------------
      SUBROUTINE write_itype(n,itype)
      integer*4 itype(n)
      write(3) itype
      RETURN
      end
c---------------------------------------------------------------
