      SUBROUTINE find_hd(N,Lg,ll,r,v,h,dn,e,ihc,xscale)
c
c  finds h and dn for those particles that remain to be done and
c  that have Nsph or more neighbours.
c
      include 'psize.inc'
c
      integer ihc(Lg,Lg,Lg),ll(N)
      real r(3,N),v(3,N),h(N),dn(N),e(N)
c  r2 and index are for neighbour list.  They can probably be made MUCH smaller
c      parameter(ngppmax=Nmax/64)
      parameter(ngppmax=Nmax/2)
      real r2(ngppmax)
      integer index(ngppmax),ipart(ngppmax)
c  accounting
      integer jnbox(-1:1,-1:1,-1:1)
      real radd(0:Lgmax+1),rxadd(-1:1),ryadd(-1:1),rzadd(-1:1)
      integer indx(0:Lgmax+1),inx(-1:1),iny(-1:1),inz(-1:1)
c  sph
      parameter(nsph=32)
      logical firstcall
      real kernel, wtab(0:ntp+1)
      real rpp(3),dr(3),dppv(3)
      save wtab,firstcall
      parameter(wtophatnorm=3./32./pi)
      data firstcall/.true./

c  On the first call evaluate the smoothing kernel
      if (firstcall) then
         firstcall=.false.
c  No bias from sitting on particle
c         wtab(0)=0.
         wtab(0)=kernel(0.00001)
         do i=1,ntp
            rad2=float(i)*4./float(ntp)
            rad=sqrt(rad2)
            wtab(i)=kernel(rad)
         end do
      end if
c
c  Maximum search length
      twohmax=1./xscale
c
c  Set up wrapping         
      radd(0)=-1.
      indx(0)=Lg
      do i=1,Lg
         radd(i)=0.
         indx(i)=i
      enddo
      radd(Lg+1)=1.
      indx(Lg+1)=1
c     
c  loop over central boxes
      do ibz=1,Lg
         do iby=1,Lg
            do ibx=1,Lg

c  do wrapping
      do i=-1,1
         rxadd(i)=radd(ibx+i)
         ryadd(i)=radd(iby+i)
         rzadd(i)=radd(ibz+i)
         inx(i)=indx(ibx+i)
         iny(i)=indx(iby+i)
         inz(i)=indx(ibz+i)
      enddo
c
c  loop over neighbouring boxes setting up temporary linked lists 
      do nbz=-1,1
         do nby=-1,1
            do nbx=-1,1
               jnbox(nbx,nby,nbz)=ihc(inx(nbx),iny(nby),inz(nbz))
            enddo
         enddo
      enddo
c
c  Loop over particles in central box --------------------------------
      i=jnbox(0,0,0)
      do while (i.gt.0)
c
c  if particle already done then skip to end of loop
         if (h(i).gt.0.) GOTO 2
         ngpp=0
         rpp(1)=r(1,i)
         rpp(2)=r(2,i)
         rpp(3)=r(3,i)
c     
c     Loop over neighbour boxes =========================================
         do nbz=-1,1
            r3i=rpp(3)-rzadd(nbz)
            do nby=-1,1
               r2i=rpp(2)-ryadd(nby)
               do nbx=-1,1
                  r1i=rpp(1)-rxadd(nbx)
c     
c     loop over particles in box +++++++++++++++++++++++++++++++++++
                  j=jnbox(nbx,nby,nbz)
                  do while (j.gt.0) 
                     if (j.ne.i) then
                        ngpp=ngpp+1
      if (ngpp.gt.ngppmax) STOP 'find_hd: ngpp>ngppmax'
                        ipart(ngpp)=j
                        dr(3)=r(3,j)-r3i
                        dr(2)=r(2,j)-r2i
                        dr(1)=r(1,j)-r1i
                        r2(ngpp)=dr(1)**2+dr(2)**2+dr(3)**2
                     end if
                     j=ll(j)
                  end do
c     finished box ++++++++++++++++++++++++++++++++++++++++++++++++++
c     
               enddo
            enddo
         enddo
c     finished neighbour boxes ======================================
c
c  Process particle if it has enough neighbours     
         if (ngpp.ge.nsph) then
c  find separation of nsph'th neighbour
            r2nsph=SELECT_INDEX(nsph,ngpp,r2,index)
            twoh=sqrt(r2nsph)
c  process particle if twoh is less than search length
            if (twoh.le.twohmax) then
               h(i)=0.5*twoh
               ngpp=nsph
               hppi=1./h(i)
               hpp2i=hppi**2
               rad2torbin=(0.25*float(ntp))*hpp2i
               dpp=wtab(0)
               dppv2=0.
               do k=1,3
                  dppv(k)=dpp*v(k,i)
                  dppv2=dppv2+dpp*v(k,i)**2
               end do
               do isort=1,ngpp
                  igpp=index(isort)
                  j=ipart(igpp)
                  rbin=rad2torbin*r2(igpp)
                  ibin=int(rbin)
                  fbin=rbin-ibin
                  w=wtab(ibin)+fbin*(wtab(ibin+1)-wtab(ibin))
                  dpp=dpp+w
                  do k=1,3
                     dppv(k)=dppv(k)+w*v(k,j)
                     dppv2=dppv2+w*v(k,j)**2
                  end do
               end do
               dppv2=dppv2/dpp
               do k=1,3
                  dppv2=dppv2-(dppv(k)/dpp)**2
               end do
               e(i)=0.5*dppv2
               dn(i)=dpp*hppi*hpp2i
c  this line is for top-hat
c            dn(i)=wtophatnorm*ngpp*hppi*hpp2i
            end if
c
         end if
c
c  next particle in central box     
 2       i=ll(i)
      enddo
c     
c  finished loop over particles in central box -------------------------
            enddo
         enddo
      enddo
c
      return
      end


