      SUBROUTINE grid(N,itype,r,v,h,e,dn)
c
c  sph adapted for use with darkdens.
c  It uses successively coarser grids
c
      include 'psize.inc'
      parameter(ratioLg=0.5,Lgmin=3)
c
      integer ihc(Lgmax,Lgmax,Lgmax),ll(Nmax)
      integer itype(N)
      real r(3,N),v(3,N)
      real h(N),dn(N),e(N)
      real xmin(3)
c  control flags
      logical isolated
c
c  decide whether to wrap gas or not
      isolated=.false.
#ifdef ISOLATED
      isolated=.true.
#endif
c
c  extent of gas particles
      if (isolated) then
         CALL extent_gas(N,itype,r,xmin,xsize)
      else
         do j=1,3
            xmin(j)=0.
         enddo
         xsize=1.
      end if
c     end if
c
c  define whether a padding cell is required
      if (isolated) then
         Lgoff=1
      else
         Lgoff=0
      end if
c
c  Loop over grids
c  ---because we do not know the h's, we have to do the finest grid first
      Lg=Lgmax
      itodo=N
      do while(Lg.ge.Lgmin .and. itodo.gt.0)
         cpu0=cputime()
         print*,'Lg = ',Lg
c  Sort into grid
         xscale=float(Lg-Lgoff)/xsize
         print*,'  entering listg'
         call listg(N,r,itype,ll,Lg,Lgoff,ihc,xmin,xscale)
c  Call neighbour-finding routine
         print*,'  entering find_hd'
         CALL find_hd(N,Lg,ll,r,v,h,dn,e,ihc,xscale)
c  Set new Lg and count remaining particles
         Lg=int(float(Lg)*ratioLg)
         itodo=0
         do i=1,N
            if (h(i).le.0.) then
               itodo=itodo+1
            endif
         enddo
         cpu1=cputime()
         print*,'  loop took ',cpu1-cpu0,' seconds.'
         print*,'  ',N-itodo,' particles done, ',itodo,' remain'
      enddo
c                 
      RETURN
      end
