      SUBROUTINE readdata
c
c  reads data from startup file
c
      include 'psize.inc'
#include "rvarrays.inc"
      include 'pinfo.inc'
      include 'iodefs.inc'
      include 'version.inc'
c
#ifdef BYTE_SWAP
      character longfile_swap*60,longfile*65
#else
      character longfile*60
#endif
#ifdef SAVE_ACCEL
      logical save_accel
#endif
c
#ifdef BYTE_SWAP
      longfile_swap='data/'//datafile
      longfile=longfile_swap(1:lnblnk(longfile_swap))//'_swap'
      CALL byte_swap(longfile_swap(1:lnblnk(longfile_swap)),
     &               longfile(1:lnblnk(longfile)))
#else
      longfile='data/'//datafile
#endif
      open(3,file=longfile,status='old',form='unformatted',iostat=ier)
      if (ier.ne.0) then
         print*,'Error opening ',longfile
         STOP 
      end if
c
#ifdef SAVE_ACCEL
      save_accel = .false.
      if(datafile(7:10).eq.'back'.or.datafile(7:10).eq.'data')
     &     save_accel=.true.
#endif
c
c  read version number and halt or warn if incorrect
      read(3) iversion0,iversion1,iversion2
      if (iversion0.ne.version0) then
         print*,'Fatal error: incorrect version for data'
         print*,'  data is of version ',iversion0,'.',iversion1,
     &        '.',iversion2
         print*,'  hydra is version ',version0,'.',version1,
     &        '.',version2
         STOP
      else if (iversion1.ne.version1 .or. iversion2.ne.version2) then
         print*,'Warning: old (but compatible) data'
         print*,'  data is of version ',iversion0,'.',iversion1,
     &        '.',iversion2
         print*,'  hydra is version ',version0,'.',version1,
     &        '.',version2
      end if
c
c  read header
      read(3) ibuf,ibuf1,ibuf2
      if(nobj.gt.Nmax) STOP 'readdata: N>Nmax'
      if(ngas.gt.Nmaxgas) STOP 'readdata: Ngas>Nmaxgas'
c
c  Have to read data in separate calls otherwise too slow
      CALL read_itype(nobj,itype)
      CALL read_scalar(nobj,rm)
      CALL read_vector(nobj,r)
      CALL read_vector(nobj,v)
#ifndef NOSPH
      if (ngas.gt.0) then
         CALL read_scalar(ngas,h)
         CALL read_scalar(ngas,e)
         CALL read_scalar(ngas,dn)
#ifdef ZMET
         CALL read_scalar(ngas,zmet)
#endif
#ifdef SAVESTAR
         if (itime.gt.0 .and. lcool.eq.1) then
            CALL read_scalar(ngas,startime)
            CALL read_itype(ngas,galindex)
         end if
#endif
      end if
#endif
#ifdef SAVE_ACCEL
      if(save_accel) CALL read_vector(nobj,a)
#ifndef NOSPH
      if (save_accel .and. ngas.gt.0) CALL read_scalar(ngas,de)
#ifdef ENTROPY
      if (save_accel .and. ngas.gt.0) CALL read_scalar(ngas,ds)
#endif
#endif
#endif
      close(3)
c
#ifdef BYTE_SWAP
      CALL rm_sys(longfile)
#endif
c
      RETURN
      end
c---------------------------------------------------------------
      SUBROUTINE read_scalar(n,s)
      real*4 s(n)
      read(3) s
      RETURN
      end
c---------------------------------------------------------------
      SUBROUTINE read_vector(n,s)
      real*4 s(3,n)
      read(3) s
      RETURN
      end
c---------------------------------------------------------------
      SUBROUTINE read_itype(n,itype)
      integer*4 itype(n)
      read(3) itype
      RETURN
      end
c---------------------------------------------------------------
