      PROGRAM readheader
c
c  reads the header of a hydra data file
c  and (optionally) some sample particles
c
      include 'psize.inc'
      include 'pinfo.inc'
#include "rvarrays.inc"
      include 'itype.inc'
      include 'iodefs.inc'
c
      character*1 answer
c
 1    print*,'Which datafile?'
      read(*,'(a)') datafile
c
      CALL readdata
c
#ifndef NOEXPAND
      CALL ahtime(1.,omega0,xlambda0,atime0,h0t0)
      CALL ahtime(time,omega0,xlambda0,atime,htime)
#endif
c
      nstar=0
      do i=1,nobj
         if (itype(i).eq.itstar) nstar=nstar+1
      enddo
      print*,'Run number            : ',irun
      print*,'Current step number   : ',itime
      print*,'Nobj,ndark,ngas,nstar : ',nobj,ndark,ngas,nstar
      print*
      print*,'Time                  : ',time
#ifndef NOEXPAND
      print*,'Boxsize (h-1Mpc)      : ',box100
      print*,'Expansion factor      : ',atime
      print*,'Redshift              : ',1./atime-1.
      print*,'Hubble parameter      : ',htime
      print*
      print*,'h (H_100 = 1)         : ',h100
      print*,'omega at t=1          : ',omega0
      print*,'lambda at t=1         : ',xlambda0
#endif
#ifdef ISOLATED
      if (rmax2.gt.0.) then
         print*,'Box radius            : ',sqrt(rmax2)
      else
         print*,'Box radius            : not yet set'
      end if
#endif
      if (lcool.eq.1) print*,'Cooling               : on'
      if (lcool.eq.0) print*,'Cooling               : off'
      print*,'Metallicity           : ',zmet0
      print*
      print*,'Time (and redshifts) of requested dumps;'
      do i=1,50
      if (tout1(i).gt.0.) then
#ifdef NOEXPAND
         print*,i,tout1(i)
#else
         CALL ahtime(tout1(i),omega0,xlambda0,atime,htime)
         print*,i,tout1(i),1./atime-1.
#endif
      endif
      enddo
c
c  calculate size of PM mesh
c
      ilp=nobj**(1./3.)
      ic=0
      do while (ilp.ne.0)
	ilp=ilp/2
        ic=ic+1
      enddo
      L=max(16,2**ic)
      if (L.gt.Lmax) then
	print*,'*** Warning *** Lmax is too small for N'
	print*,'Would like Lmax = ',L
	L=Lmax
      endif	      
      if (L.lt.Lmax) print*,'Lmax could be reduced to ',L
      if (L.eq.Lmax) print*,'L = ',L
c
      if (Nmax.gt.nobj) print*,'Nmax could be reduced to ',nobj
      if (Nmax.lt.nobj) then
	print*,'*** Error *** Nmax is too small'
	print*,'Change Nmax to ',Nobj,' in psize.inc'
      endif	
c
#ifdef ISOLATED
      if (L.gt.Lpmax) then
	print*,'*** Error *** Lpmax is too small'
	print*,'Change Lpmax to ',L,' in psize.inc'
      endif
#endif
c
      Lsave=L
c
      print*
      print*,'More info ? (y/n)'
      read(*,'(a)') answer
      if (answer.eq.'y' .or. answer.eq.'Y') then
         big=1.e30
         small=-1.e30
         rmmax=small
         rmmin=big
         rxmax=small
         rymax=small
         rzmax=small
         rxmin=big
         rymin=big
         rzmin=big
         vxmax=small
         vymax=small
         vzmax=small
         vxmin=big
         vymin=big
         vzmin=big
         densmax=small
         densmin=big
         tmax=small
         tmin=big
         hmax=small
         hmin=big
         rmmean=0.
         rxmean=0.
         rymean=0.
         rzmean=0.
         vxmean=0.
         vymean=0.
         vzmean=0.
         densmean=0.
         tmean=0.
         hmean=0.
c
         call showpar(1)
         if (ngas.eq.0 .or. ndark.eq.0) then
            ioth=nobj/2
         else
	    ioth=ngas+1
         endif
         if (ioth.le.nobj) call showpar(ioth)
c
         do i=1,nobj
            rmmax=max(rmmax,rm(i))
            rmmin=min(rmmin,rm(i))
            rxmax=max(rxmax,r(1,i))
            rymax=max(rymax,r(2,i))
            rzmax=max(rzmax,r(3,i))
            rxmin=min(rxmin,r(1,i))
            rymin=min(rymin,r(2,i))
            rzmin=min(rzmin,r(3,i))
            vxmax=max(vxmax,v(1,i))
            vymax=max(vymax,v(2,i))
            vzmax=max(vzmax,v(3,i))
            vxmin=min(vxmin,v(1,i))
            vymin=min(vymin,v(2,i))
            vzmin=min(vzmin,v(3,i))
            rmmean=rmmean+rm(i)
            rxmean=rxmean+r(1,i)
            rymean=rymean+r(2,i)
            rzmean=rzmean+r(3,i)
            vxmean=vxmean+v(1,i)
            vymean=vymean+v(2,i)
            vzmean=vzmean+v(3,i)
         end do
         do i=1,ngas
            densmax=max(densmax,dn(i))
            densmin=min(densmin,dn(i))
            tmax=max(tmax,e(i))
            tmin=min(tmin,e(i))
            hmax=max(hmax,h(i))
            hmin=min(hmin,h(i))
            densmean=densmean+dn(i)
            tmean=tmean+e(i)
            hmean=hmean+h(i)
         end do
         fni=1./float(nobj)
         print*,'mass max,min,mean ',rmmax,rmmin,rmmean*fni
         print*,' x   max,min,mean ',rxmax,rxmin,rxmean*fni
         print*,' y   max,min,mean ',rymax,rymin,rymean*fni
         print*,' z   max,min,mean ',rzmax,rzmin,rzmean*fni
         print*,'vx   max,min,mean ',vxmax,vxmin,vxmean*fni
         print*,'vy   max,min,mean ',vymax,vymin,vymean*fni
         print*,'vz   max,min,mean ',vzmax,vzmin,vzmean*fni
         if (ngas.ne.0) then
            fngi=1./float(ngas)
            print*,'dens max,min,mean ',densmax,densmin,densmean*fngi
            print*,'temp max,min,mean ',tmax,tmin,tmean*fngi
            print*,' h   max,min,mean ',hmax,hmin,hmean*fngi
         end if
	 print*
c
         L=Lsave
c
         CALL inunit
c
      endif
c
      end

      subroutine showpar(i)
c
      include 'psize.inc'
#include "rvarrays.inc"
      include 'itype.inc'
c
      print*,'For particle ',i,';'
      if (itype(i).eq.itdark) print*,'Dark matter'
      if (itype(i).eq.itgas)  print*,'Gas'
      if (itype(i).eq.itstar)  print*,'Star'
      print*,'Mass = ',rm(i)
      print*,'x,y,z = ',r(1,i),r(2,i),r(3,i)
      print*,'vx,vy,vz = ',v(1,i),v(2,i),v(3,i)
      if (itype(i).eq.itgas) then
         print*,'Density  = ',dn(i)
         print*,'Temperature = ',e(i)
      endif
      print*
c
      RETURN	
      end
